	list		p=16f1827      ; list directive to define processor
	#include	<p16f1827.inc> ; processor specific variable definitions  

    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_SWDTEN & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF
  
 ; z 16F1840:
 ;   __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_ON & _CLKOUTEN_OFF & _IESO_ON & _FCMEN_ON
 ;   __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_ON & _BORV_LO & _LVP_OFF

	
	CBLOCK		0x20
		N1	
		N10		
		N100
		p_50us	
		p_2ms
		p_40ms
		ADRESA_EEPROM
		HODNOTA_EEPROM
		TMP_RS232
		count_rs232
		PAUZA_RS232
		TMP_I2C
		countI2C
		SWR
		SWR2
		VYBER_RADU_FREKVENCIE
		WDT_0
		WDT_1
		TMP_UART
		LCD_BUFER
		POCET
		POCET_BCD
		ZACIATOK_LCD
		TMP_LCD
		CNT_LCD
		CNT_TMR1
		HODNOTA_BCD		;26
			;MAX 96 bajtov (80+16)
	ENDC



	#define		LCD_DB4			PORTA,4
	#define		LCD_DB5			PORTA,3
	#define		LCD_DB6			PORTA,2
	#define		LCD_DB7			PORTA,1
	#define		LCD_E			PORTA,7
	#define		TX_UART			PORTA,6
	#define		LCD_RS			PORTA,0

	#define		TLAC_DN			PORTB,1
	#define		TLAC_UP			PORTB,0
	#define		EN_A			PORTB,3
	#define		EN_B			PORTB,2
	#define		SCL				PORTB,4
	#define		SDA				PORTB,5

	#define		TL				PORTB,6



	#define		EN_A_TMP				SWR,0
	#define		EN_B_TMP				SWR,1
	#define		I2C_stav_ACK			SWR,2
	#define		Vynulovanie				SWR,3
	#define		Pretecenie_nastalo		SWR,4
	#define		Spodny_prah				SWR,5
	#define		Vrchny_prah				SWR,6
	#define		Dorovnanie_na_500kHz	SWR,7

	#define		Jednorazovo_zapni		SWR2,0



; Oscilator 32 MHz
;	#define		Baud_rs232				.184 ;.174 - 193 = 14400 baud
;	#define		Baud_rs232				.135 ;.128 - 141 = 19200 baud
	#define		Baud_rs232				.65 ; .62 - 68 = 38400 baud	
;	#define		Baud_rs232				.42 ; .40 - 44 = 57600 baud
;	#define		Baud_rs232				.19 ; .18 - 20 = 115200 baud
;	#define		Baud_rs232				.16 ; .16 - 17 = 128000 baud
;	#define		Baud_rs232				.6 ; 		   = 256000 baud




	#define		rychlost_morze					.20




		;Adresy BCD cisel------------------------------------BANK 1---------------------
	#define		Pocet_cislic					.8		; =pocet registrov BCD
	#define		Adr_H_BCD_cisla					0x00	
	#define		Adr_L_BCD_cisla					0xA0 + 0*Pocet_cislic
		; 8 bajtov ooooo
	#define		Adr_L_BCD_cislaNORM				0xA0 + 1*Pocet_cislic
	#define		Adr_L_BCD_cislaRIT				0xA0 + 2*Pocet_cislic

	#define		Hodnota_wdt_inkrementalu		0xFF
	#define		krok_ladenia_frekvencie			.4

;***************************************************************************************************************************
	org		000h
	GOTO	START	
;***************************************************************************************************************************
	org		004h
	goto 	prerusenie
;************************************************* PODPROGRAMY *************************************************************

								;-----u-----;
			;D2			D2		; RA2	RA1 ; 	  D1		D3
			;D1			D3		; RA3	RA0 ; 	  D0		RS
			;D0			E		; RA4	RA7 ;	  RS		E
			;				Vpp ; RA5	RA6 ;	  TX_UART
			;				(-)	;-Vss	Vdd+; (+)
			;		Tlac.DN		; RB0	RB7 ; PGD
			;		TLac.UP		; RB1	RB6 ; PGC			prepinac
			;	EN_A (zeleny)	; RB2	RB5 ;	  SDA
			;	EN_B (biely)	; RB3	RB4 ;	  SCL
								;-----------;
;												lavy je A
;												pravy je B

nastavenie_PIC
;NASTAVENIE PORTOV (I/O)
		BANKSEL TRISA ;-------------------------------------- bank 1 ----------------------------------------------------
		MOVLW 	b'00000000' 	; RA2-out-LED  RA4-out-TX_RS232  RA5-inpt-RX_RS232
		MOVWF 	TRISA 
		MOVLW 	b'01111111' 
		MOVWF 	TRISB 
;FREKVENCIA OSC
		movlw	b'11110000'		; bit7 zapnutie 4xPLL; bity6-3 frekvencia (32 MHz)
		movwf	OSCCON	
;NASTAVENIA ROZNE
		movlw	b'00000000'		; WPUEN: Pull-up disable; INTEDG: Interrupt Edge falling of INT pin 
		movwf	OPTION_REG
;PRERUSENIA (timer atd..)
		movlw	b'10000001'
		movwf	PIE1
;WATCHDOG
		;movlw	b'00011001'		;4s bit 5-1 prescale; bit 0 on/off
		movlw	b'00010110'		;2s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010101'		;1s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010011'		;512ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010001'		;256ms 5-1 prescale; bit 0 on/off
		;movlw	b'00001111'		;128ms bit 5-1 prescale; bit 0 on/off
		movwf	WDTCON			; nastavenie WATCHDOG
;ANALOGOVE I/O
		BANKSEL ANSELA 	;----------------------------------- bank 3 ----------------------------------------------------
		clrf 	ANSELA 
		clrf 	ANSELB
;PULLUP ODPORY
		banksel  WPUB	;----------------------------------- bank 4 ----------------------------------------------------
		movlw	b'01111111'
		movwf	WPUB
;PRERUSENIA NA PINOCH OD SPADOVEJ HRANY
		banksel  IOCBN	;----------------------------------- bank 7 ----------------------------------------------------
		movlw	b'00001111'
		movwf	IOCBN
		clrf	IOCBF
		BANKSEL PORTA	;----------------------------------- bank 0 ----------------------------------------------------
;TIMER 1
		movlw	b'00110100'
		movwf	T1CON
		clrf	TMR1H
		clrf	TMR1L
		clrf	PIR1
;PRERUSENIA VSEOBECNE
		movlw	b'01001000'	; bit7 GIE: 1=global interrupt ;bit6 PEIE: 1=peripheral interrupt
		movwf	INTCON		
;PORTY	
		clrf	PORTA
		clrf	PORTB	
		call	vycistenie_GPR_banky_0
		call	vycistenie_GPR_banky_1
		call	vycistenie_GPR_banky_2
		call	vycistenie_GPR_banky_3
		call	vycistenie_GPR_banky_4
	return






vycistenie_GPR_banky_0
		movlw	.96				; 80 bajtov GPR v kazdej banke
		movwf	0x20
		clrf	FSR0H
		movlw	0x20+1 			; druhy bajt GPR banky 0 (prvy bajt je pocitadlo)
		movwf	FSR0L
	opakuj_nulovanie_bajtov_0
		clrf	INDF0
		incf	FSR0L,f
		decfsz	0x20,f
		goto	opakuj_nulovanie_bajtov_0
	return



vycistenie_GPR_banky_1
		movlw	.80				; 80 bajtov GPR v kazdej banke
		movwf	0x20
		clrf	FSR0H
		movlw	0xA0 			; druhy bajt GPR banky 0 (prvy bajt je pocitadlo)
		movwf	FSR0L
	opakuj_nulovanie_bajtov_1
		clrf	INDF0
		incf	FSR0L,f
		decfsz	0x20,f
		goto	opakuj_nulovanie_bajtov_1
	return


vycistenie_GPR_banky_2
		movlw	.80				; 80 bajtov GPR v kazdej banke
		movwf	0x20
		movlw	0x01
		movwf	FSR0H
		movlw	0x20 			; druhy bajt GPR banky 0 
		movwf	FSR0L
	opakuj_nulovanie_bajtov_2
		clrf	INDF0
		incf	FSR0L,f
		decfsz	0x20,f
		goto	opakuj_nulovanie_bajtov_2
	return


vycistenie_GPR_banky_3
		movlw	.80				; 80 bajtov GPR v kazdej banke
		movwf	0x20
		movlw	0x01
		movwf	FSR0H
		movlw	0xA0 			; druhy bajt GPR banky 0 
		movwf	FSR0L
	opakuj_nulovanie_bajtov_3
		clrf	INDF0
		incf	FSR0L,f
		decfsz	0x20,f
		goto	opakuj_nulovanie_bajtov_3
	return


vycistenie_GPR_banky_4
		movlw	.48				; 80 bajtov GPR v kazdej banke
		movwf	0x20
		movlw	0x02
		movwf	FSR0H
		movlw	0x20 			; druhy bajt GPR banky 0 
		movwf	FSR0L
	opakuj_nulovanie_bajtov_4
		clrf	INDF0
		incf	FSR0L,f
		decfsz	0x20,f
		goto	opakuj_nulovanie_bajtov_4
	return



;***********************************************************************************************
;*************************************** PAUZY *************************************************
;***********************************************************************************************

pauza		
		movwf	N100
p10		movlw	.150
		movwf	N10
		clrwdt
p1		movlw	.150
		movwf	N1
		decfsz	N1
		goto	$-1
		decfsz	N10
		goto	p1
		decfsz	N100
		goto	p10
	return			



pauza_10ms
		movlw	.127
		movwf	N10
pd1		movlw	0xFF
		movwf	N1
		decfsz	N1
		goto	$-1
		decfsz	N10
		goto	pd1
	return			



pauza_100us

		movlw	0xFF
		movwf	N1
		decfsz	N1
		goto	$-1

	return



;***********************************************************************************************
;*************************************** ZAPIS/CITANIE EEPROM **********************************
;***********************************************************************************************

	;******************************* zapis EEPROM *******************************
WRITE_EPROM
		movwf	HODNOTA_EEPROM
		banksel	EECON1
		btfsc	EECON1,WR		
		goto	$-1		
		banksel	PORTA
		movf	ADRESA_EEPROM,w				 
		banksel	EEADRL			
		movwf	EEADRL			
		banksel	PORTA			
		movf	HODNOTA_EEPROM,w				
		banksel	EEDATL		 
		movwf	EEDATL		
		banksel	EECON1
		bcf		EECON1, CFGS 
		bcf 	EECON1, EEPGD 
		bsf 	EECON1, WREN 
;		bcf 	INTCON, GIE  
		movlw	0x55	
		movwf	EECON2	
		movlw	0xAA	 
		movwf	EECON2	
		bsf 	EECON1, WR 
;		bsf 	INTCON, GIE 
		bcf 	EECON1, WREN 
		btfsc 	EECON1, WR 
		GOTO 	$-2
		banksel	PORTA
	return


	;******************************* citanie z EEPROM *******************************
READ_EPROM
		movwf	ADRESA_EEPROM
		banksel	EEADRL
		movwf	EEADRL
		bcf 	EECON1, CFGS 
		bcf 	EECON1, EEPGD
		bsf 	EECON1, RD 
		movf 	EEDATL, W
		banksel	PORTA
	return



;**************************************************************************************************
;********************************* Softverovy USART RS232 ******************************************
;**************************************************************************************************


cakaj_uart_bit				
		movlw	Baud_rs232	
		movwf	PAUZA_RS232	
		decfsz	PAUZA_RS232,f
		goto	$-1	
	return
		

cakaj_uart_polbit				
		movlw	Baud_rs232/3
		movwf	PAUZA_RS232	
		decfsz	PAUZA_RS232,f
		goto	$-1	
	return
		


USART_TXW
			;z W registra vloz hodnotu na vysielanie
		movwf	TMP_RS232
			;nastav pocitadlo na vyslanie 8 datovych bitov
		movlw	.8
		movwf	count_rs232	
			;vyslanie STOP bitu
		bsf		TX_UART
		call	cakaj_uart_bit	
;		call	cakaj_uart_bit	
			;vyslanie START bitu
		bcf		TX_UART
		call	cakaj_uart_bit
scitx1
				;vysielanie datovych bitov 
			rrf		TMP_RS232,f
			btfsc	STATUS,C
			bsf		TX_UART			
			btfss	STATUS,C
			bcf		TX_UART	
			call	cakaj_uart_bit
			;opakuj 8 bitov
		decfsz	count_rs232,f
		goto	scitx1	
			;vyslanie STOP bitu
		bsf		TX_UART				
		call	cakaj_uart_bit	
		call	cakaj_uart_bit	
	return



;================================================================================================
;===================================== SSP I2C softverova implementacia =========================
;================================================================================================
;#ifdef K



	;logicka 0 je stiahnutie linky do nuly nastavenim pinu ako OUTPUT pripojeny na kostru
I2C_SDA_0
		bcf		SDA		;vynulovanie (preddefinovane vypnutie) pinu SDA
		banksel	TRISA
		bcf		SDA		;nastavenie SDA ako OUTPUT (pripojeny na 0)
		banksel	PORTA
	return

	;logicka 1 je uvolnenie linky nastavenim pinu ako INPUT, ktora sa dostane do 1 vdaka PULL-UP odporu
I2C_SDA_1
		banksel	TRISA
		bsf		SDA		;nastavenie SDA ako INTPUT (pin sa otvri)
		banksel PORTA
	return

	;dolna polperioda hodin stiahnutim linky do nuly nastavenim pinu ako OUTPUT pripojeny na kostru
I2C_SCK_0
		bcf		SCL		;vynulovanie (preddefinovane vypnutie) pinu SCL
		banksel	TRISA
		bcf		SCL		;nastavenie SCA ako OUTPUT (pripojeny na 0)
		banksel PORTA
	return

	;horna polperioda hodin je uvolnenie linky nastavenim pinu ako INPUT
I2C_SCK_1
		banksel	TRISA
		bsf		SCL		;nastavenie SCA ako INTPUT (pin sa otvri)
		banksel PORTA
	return


	;Pauza polperiody hodinoveho signalu
pauza_i2c
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
	return


	;Pauza stvrtperiody hodinoveho signalu
pol_pauzy_i2c
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
	return


	;START prenosu. Stiahnutie SDA do 0, kym je SCL v 1. To je povel k STARTu prenosu.
I2C_START	
		call	I2C_SDA_1
		call	I2C_SCK_1
		call	pauza_i2c
		call	pauza_i2c
		call	I2C_SDA_0			;START sekvencia
		call	pauza_i2c
	return


	;Opakovany START prenosu. Najprv sa musi SCL zdvihnut do 1, kym je SDA uz v 1.
	;Potom sa SDA stiahne do 0. To je povel k opakovanemu STARTu prenosu
I2C_START_REPEATED
		call	I2C_SCK_0
		call	I2C_SDA_1
		;call	I2C_SCK_0
		call	pauza_i2c
		call	I2C_SCK_1
		call	pauza_i2c
		call	I2C_SDA_0			;opakovana START sekvencia
		call	pauza_i2c
	return


	;Vyslanie bajtu adresy alebo dat. Bity sa vysuvaju od 7 po 0. 
	;Bit 0 adresy prepina medzi zapisom na adresu / citanim adresy.
I2C_TXW
		movwf	TMP_I2C
		movlw	.8
		movwf	countI2C
			;Stiahnutie hodin do 0
		call	I2C_SCK_0
		;Vysielanie 8 bitov
	opakuj_tx_i2c
			call	pol_pauzy_i2c
				;bity musia menit svoj stav uprostred dolnej polperiody hodin
			rlf		TMP_I2C,f
			btfsc	STATUS,C
			call	I2C_SDA_1
			btfss	STATUS,C
			call	I2C_SDA_0
				;Hodinovy pulz
			call	pol_pauzy_i2c
			call	I2C_SCK_1
			call	pauza_i2c			;horna polperioda hodin
			call	I2C_SCK_0
		;opakuj vysielanie bitov 8x
	decfsz	countI2C
	goto	opakuj_tx_i2c
		call	pauza_i2c
			;Prepni na prijem a testuj pocas deviateho hodinoveho pulzu pritomnost ACK od Slave
		call	I2C_SDA_1	; prepne na prijem (port SDA ako INPUT), kym je SCL v nule
			;Deviaty hodinovy impulz
		call	I2C_SCK_1
		call	pol_pauzy_i2c
			;Testuj pritomnost ACK od Slave
		;call	I2C_SDA_1		; prepne na prijem (port SDA ako INPUT)
		btfsc	SDA
		bsf		I2C_stav_ACK
		btfss	SDA
		bcf		I2C_stav_ACK
		call	pol_pauzy_i2c
			; dolna polperioda hodin
		call	I2C_SCK_0		
		;call	pol_pauzy_i2c
		call	pauza_i2c
	return


	;Citanie bajtu
I2C_RXW
		movlw	.8
		movwf	countI2C
			; prepni na prijem (port SDA ako INPUT)
		call	I2C_SDA_1
			;Pauza, pocas ktorej slave nahodi stav prveho bitu (hodiny su z predosleho v nule)
		call	pauza_i2c
			; prepni na prijem (port SDA ako INPUT)
		;call	I2C_SDA_1		
			;Prijem 8 datovych bitov do premennej
	opakuj_rx_i2c
				;horna polperioda hodin
			call	I2C_SCK_1			
			call	pol_pauzy_i2c
				;uprostred hornej polperiody hodin testuj stav pinu SDA a ukladaj bity do registra
			btfsc	SDA
			bsf		STATUS,C
			btfss	SDA
			bcf		STATUS,C		
			rlf		TMP_I2C,f
			call	pol_pauzy_i2c
				;Dolna polperioda hodin, pocas ktorej Slave zmeni/ponecha stav dalsieho bitu
			call	I2C_SCK_0
			call	pauza_i2c
	decfsz	countI2C
	goto	opakuj_rx_i2c
		;call	pauza_i2c
			;Stiahnutie linky SDA do 0 pre vyslanie ACK na pokracovanie prijmu dalsich bitov
		call	I2C_SDA_0
		call	pauza_i2c
			;Hodiny do hornej polperiody 
		call	I2C_SCK_1
		call	pauza_i2c
		call	I2C_SCK_0
		call	pauza_i2c
			;Vlozenie prijatych dat do W registra
		movf	TMP_I2C,w
	return


	;Citanie posledneho bajtu.
I2C_RXW_POSLEDNE
		movlw	.8
		movwf	countI2C
			; prepni na prijem (port SDA ako INPUT)
		call	I2C_SDA_1
			;Pauza, pocas ktorej slave nahodi stav prveho bitu
		call	pauza_i2c
			; prepni na prijem (port SDA ako INPUT)
		;call	I2C_SDA_1
	opakuj_rx_i2c_end
				;horna polperioda hodin
			call	I2C_SCK_1
			call	pol_pauzy_i2c
				;uprostred hornej polperiody hodin testuj stav pinu SDA a ukladaj bity do registra
			btfsc	SDA
			bsf		STATUS,C
			btfss	SDA
			bcf		STATUS,C		
			rlf		TMP_I2C,f
			call	pol_pauzy_i2c
				;Dolna polperioda hodin, pocas ktorej Slave zmeni/ponecha stav dalsieho bitu
			call	I2C_SCK_0
			call	pauza_i2c
	decfsz	countI2C
	goto	opakuj_rx_i2c_end
		;call	pauza_i2c
			;Linka SDA sa ponecha uvolnena, cim je ACK vypnute. Dalsi prijem uz totiz nechceme.
		call	I2C_SDA_1
		call	pauza_i2c
			;Hodiny do hornej polperiody 
		call	I2C_SCK_1
		call	pauza_i2c
		call	I2C_SCK_0
		call	pauza_i2c
			;Vlozenie prijatych dat do W registra
		movf	TMP_I2C,w
	return




	;STOP prenosu. Najprv sa musi SCL zdvihnut do 1, kym je SDA v 0.
	;Potom sa zvihne SDA do 1, co znamena povel STOP prenosu.
I2C_STOP
		call	I2C_SCK_0
		call	I2C_SDA_0
		call	pauza_i2c
		call	I2C_SCK_1
		call	pauza_i2c
		call	I2C_SDA_1		;STOP sekvencia
		call	pauza_i2c
	return



;********************************************************************************************************
;*************************** PODPROGRAMY PRE OBSLUHU LCD DISPLEJA **********************************
;********************************************************************************************************

	;************************************* presne pauzy *************************************

		; 32MHz/4 = 8MHz -> 1/8MHz = 0.125us
cakaj_50us						; call = 2 +
		movlw	.131		;x 	; 1 +
		movwf	p_50us			; 1 +
		decfsz	p_50us,F		; 131 * 3 - 1 +
		goto	$-1				; 
		nop						;
		nop						;
	return						; 2
		; (5 + 131 * 3) * 0.125 us = 49,75 us
		; 50 - 49,75 = 0.25/0.125 = 2 NOP
		; t = 0.125 * (5 + 3x)
		; x = (t/0.125 - 5)/3
		; x = t/0.375 - 5/3
		; x = 50/0.375 - 5/3
		; x = 131.67



		; 2000us/50us = 40
cakaj_2ms						; call = 0.25 us		
		movlw	.40				; 0.125 us +			
		movwf	p_2ms			; 0.125 us +
c_2ms	call	cakaj_50us		; 40 * 50 us +
		decfsz	p_2ms,F			; (40 * 3 - 1) * 0.125 us +
		goto	c_2ms			;															
	return						; 0.25 us
		; 0.75 + 2000 us + 14,875 = 2,015625 ms 
	

						
		; 40ms/2ms = 20
cakaj_40ms						; call = 0.25 us
		movlw	.20				; 0.125 us +
		movwf	p_40ms			; 0.125 us +
c_40ms	call	cakaj_2ms		; 20 * 2015,625 us +		
		decfsz	p_40ms,F		; (20 * 3 - 1) * 0.125 us +
		goto	c_40ms			;																							
	return						; 0.25 us
		 ; 0.75 + 40312,5 us + 7,375 = 40,320625 ms



		; 20ms/2ms = 10
cakaj_20ms						; call = 0.25 us
		movlw	.5				; 0.125 us +
		movwf	p_40ms			; 0.125 us +
c_20ms	call	cakaj_2ms		; 20 * 2015,625 us +		
		decfsz	p_40ms,F		; (20 * 3 - 1) * 0.125 us +
		goto	c_20ms			;																							
	return						; 0.25 us
		 ; 0.75 + 40312,5 us + 7,375 = 40,320625 ms



;***********************************************************************************************
;**************************************** LCD DISPLEJ ******************************************
;***********************************************************************************************

INIT_DISPLEJ_ST7066
		bcf		LCD_RS			;prepni sa do instrukcneho registra
		call	cakaj_20ms		;po zapnuti treba podla datashetu cakat 40 ms
			; posielanie dalsich bytov do LCD podprogramom urcenym na 4 bitovy prenos
;		movlw	b'00110011'
;		call	LCD_ZAPIS_4bit	 
		movlw	b'00110010'
		call	LCD_ZAPIS_4bit	 
		movlw	b'00101000'		; 3: 2/1 riadkovy rezim;  2: 5x8/5x11 bodovy format pisma.
		call	LCD_ZAPIS_4bit
		movlw	b'00001110'		; 2: display on;  1: cursor on;  0: cursor blink
		call	LCD_ZAPIS_4bit
;		movlw	b'00000001'		; 0: Display Clear
;		call	LCD_ZAPIS_4bit
		movlw	b'00000110'
		call	LCD_ZAPIS_4bit
		bsf		LCD_RS			;prepni sa do datoveho registra
		clrf	LCD_BUFER
;		call	cakaj_2ms		;potrebna pauz podla datasheetu je minimalne 1.52ms
	return



	;vymaze cely obsah LCD displeja
CLEAR_LCD
		bcf		LCD_RS			;prepni sa do instrukcneho registra
		movlw	b'00000001'		;DB4 4 bit prenos; DB3 dvoj riadkovy mod; DB2 font 5x8
		call	LCD_ZAPIS_4bit	 
		bsf		LCD_RS			;prepni sa do datoveho registra
		call	cakaj_2ms		;potrebna pauz podla datasheetu je minimalne 1.52ms
	return

	;zapis 8 bitoveho slova do LCD displeja na 2x po 4och hornych bitoch
LCD_ZAPIS_4bit
		movwf	LCD_BUFER		; obsah W registra do bufra urceneho pre LCD
		call	cakaj_50us		; caka potrebny cas aj s rezervou
		bsf		LCD_E
		nop
		nop
		call	LCD_DB4_7		; vlozi horne 4 bity bufra na vyvody DB4-DB7 LCD displeja
		nop
		nop
		bcf		LCD_E			;bit, na ktoreho zostupnej hrane nastane zapis dat do displeja
		swapf	LCD_BUFER,F		; prehodi horne a dolne 4 bity bufra urceneho pre LCD
		call	cakaj_50us		; caka potrebny cas aj s rezervou
		bsf		LCD_E
		nop
		nop
		call	LCD_DB4_7		; vlozi horne 4 bity bufra (predtym spodne) na vyvody DB4-DB7 LCD 
		nop
		nop
		bcf		LCD_E		;bit, na ktoreho zostupnej hrane nastane zapis dat do displeja
		call	cakaj_50us		; caka potrebny cas aj s rezervou
	return

	;4 bity pouzivane k zapisu datoveho slova do LCD displeja
LCD_DB4_7
		;movwf	LCD_BUFER
		btfss	LCD_BUFER,4
		bcf		LCD_DB4			; LCD - D4
		btfsc	LCD_BUFER,4
		bsf		LCD_DB4			; LCD - D4
		btfss	LCD_BUFER,5
		bcf		LCD_DB5			; LCD - D5
		btfsc	LCD_BUFER,5
		bsf		LCD_DB5			; LCD - D5
		btfss	LCD_BUFER,6
		bcf		LCD_DB6			; LCD - D6
		btfsc	LCD_BUFER,6
		bsf		LCD_DB6			; LCD - D6
		btfss	LCD_BUFER,7
		bcf		LCD_DB7			; LCD - D7
		btfsc	LCD_BUFER,7
		bsf		LCD_DB7			; LCD - D7
	return




	;Premazanie zvysnych miest od zaciatku riadka 1.
	;Na vstup sa yadava, po ktoru poziciu.
zmaz_zvysok_riadku_1_LCD
			;Nastavenie na zaciatok riadku 1 LCD
		movwf	CNT_LCD
		bcf		LCD_RS			;prepni sa do instrukcneho registra
		movlw	b'10000000'		;nastavenie ukazatela na zaciatok riadku
		call	LCD_ZAPIS_4bit
		bsf		LCD_RS			;prepni sa do datoveho registra
			;Premazanie zadaneho poctu pozicii
		movf	CNT_LCD,w
		btfsc	STATUS,Z
		goto	preskoc_mazani_LCD
		opakuj_mazanie_LCD
			movlw	' '
			call	LCD_ZAPIS_4bit
		decfsz	CNT_LCD
		goto	opakuj_mazanie_LCD
		preskoc_mazani_LCD
	return


	;adresacia prveho riadku displeja. Do W sa vklada pozicia v riadku
riadok_1_LCD
		bcf		LCD_RS			;prepni sa do instrukcneho registra	
		iorlw	b'10000000'		;zapnutie posunu v DDRAM LCD na prvom riadku. Pozicia sa pripocita z W
		call	LCD_ZAPIS_4bit	
		bsf		LCD_RS			;prepni sa do datoveho registra
	return


	;adresacia druheho riadku displeja. Do W sa vklada pozicia v riadku
riadok_2_LCD
		bcf		LCD_RS			;prepni sa do instrukcneho registra
		iorlw	b'11000000'		;zapnutie posunu v DDRAM LCD na druhom riadku. Pozicia sa pripocita z W
		call	LCD_ZAPIS_4bit	
		bsf		LCD_RS			;prepni sa do datoveho registra
	return

	;posun kurzora o jednu poziciu doprava LCD
posun_kurzora_R
		bcf		LCD_RS			;prepni sa do instrukcneho registra
		movlw	b'00010100'		
		call	LCD_ZAPIS_4bit	 
		bsf		LCD_RS			;prepni sa do datoveho registra
	return

	;posun kurzora o jednu poziciu dolava LCD
posun_kurzora_L
		bcf		LCD_RS			;prepni sa do instrukcneho registra
		movlw	b'00010000'		
		call	LCD_ZAPIS_4bit	 
		bsf		LCD_RS			;prepni sa do datoveho registra
	return






	;Ladiace nastroje
LCD_LED_ZAP
		movlw	.0
		call	riadok_2_LCD
		movlw 	'<' ;0xA5 			;bodka uprostred
		call	LCD_ZAPIS_4bit
		movlw 	'<' ;0xA5 			;bodka uprostred
		call	LCD_ZAPIS_4bit
		movlw 	'<' ;0xA5 			;bodka uprostred
		call	LCD_ZAPIS_4bit

		movlw	.5
		call	riadok_2_LCD
		movlw 	'>' ;0xA5			;bodka uprostred
		call	LCD_ZAPIS_4bit
		movlw 	'>' ;0xA5			;bodka uprostred
		call	LCD_ZAPIS_4bit
		movlw 	'>' ;0xA5 			;bodka uprostred
		call	LCD_ZAPIS_4bit

		movf	VYBER_RADU_FREKVENCIE,w
		sublw	.7
		call	riadok_1_LCD

	return



LCD_LED_VYP
		movlw	.0
		call	riadok_2_LCD
		movlw 	' '
		call	LCD_ZAPIS_4bit
		movlw 	' '
		call	LCD_ZAPIS_4bit
		movlw 	' '
		call	LCD_ZAPIS_4bit

		movlw	.5
		call	riadok_2_LCD
		movlw 	' '
		call	LCD_ZAPIS_4bit
		movlw 	' '
		call	LCD_ZAPIS_4bit
		movlw 	' '
		call	LCD_ZAPIS_4bit

		movf	VYBER_RADU_FREKVENCIE,w
		sublw	.7
		call	riadok_1_LCD

	return









;***********************************************************************************************
;******************************* PODPROGRAMY PRE OBSLUHU PRERUSENI ****************************
;***********************************************************************************************

vyhodnotenie_horneho_prahu

			bcf		Vrchny_prah

				
			movlw	.8				;pocet cislic BCD
			movwf	POCET_BCD
			opakuj_pocun_cislic2
					;Ak je kurzor na jednej z cislic...
				movlw	.1
				subwf	POCET_BCD,w
				subwf	VYBER_RADU_FREKVENCIE,w	
				btfss	STATUS,Z
				goto	preskoc_kurzor
						;...stanov pocet predchadzajucich cislic od navyssieho radu po polohu kurzora
					movf	POCET_BCD,w
					sublw	.9				;9 - pocet bcd
					movwf	POCET
						;...a skontroluj, ci tie cislice vyssich radov nie su uz deviatky.
					movlw	Adr_H_BCD_cisla
					movwf	FSR0H
					movlw	Adr_L_BCD_cisla+7
					movwf	FSR0L
				opakuj_test_deviatok
					movlw	.9
					subwf	INDF0,w
					btfss	STATUS,Z
					goto	preskoc_kurzor
					decf	FSR0L,f
					;...Ak su vsetky vyssie cislice deviatky, nedovol aktualnej cislici kde je kurzor, ist nad 9
				decfsz	POCET,f
				goto	opakuj_test_deviatok
							;...nastav priznakovy bit vrchneho prahu, tj blokadu pridavania hodnoty.
						bsf		Vrchny_prah
				preskoc_kurzor
			decfsz	POCET_BCD
			goto	opakuj_pocun_cislic2


	return





vyhodnotenie_dolneho_prahu

		;------------------------------NASTAVENIE SPODNEHO PRAHU BCD FREKVENCIE NA 500000 Hz-----------------------------

			bcf		Spodny_prah
			nop
			nop
			bcf		Dorovnanie_na_500kHz
	
				;Ak su desiatky a jednotky MHz nulove,... (alternativa 1)
			movlw	Adr_H_BCD_cisla
			movwf	FSR0H
			movlw	Adr_L_BCD_cisla+7
			movwf	FSR0L
			movf	INDF0,w
			btfss	STATUS,Z
			goto	preskoc_spodny_prah
			decf	FSR0L,f
			movf	INDF0,w
			btfss	STATUS,Z
				;Ak su desiatky a jednotky MHz nulove,... (alternativa 2)
;			movlw	.2
;			subwf	ZACIATOK_LCD,w
;			btfss	STATUS,C
			goto	preskoc_spodny_prah
					;...a zaroven ak je na stovkach kHz hodnota mensia ako 6 (tj. 5xx kHz),...
				movlw	Adr_H_BCD_cisla
				movwf	FSR0H
				movlw	Adr_L_BCD_cisla+5
				movwf	FSR0L
				movlw	.6
				subwf	INDF0,w
				btfsc	STATUS,C	;if BCD-6 < 0 then C=0
				goto	preskoc_spodny_prah
						;...nastav priznakovy bit spodneho prahu
					bsf		Spodny_prah
						;...a ak je kurzor na desiatkach alebo jednotkach MHz,...
					movlw	.6
					subwf	VYBER_RADU_FREKVENCIE,w		;if RAAD - 6 >= 0 then C=1
					btfss	STATUS,C
					goto	preskoc_spodny_prah
							;...a nastav priznakovy bit dorovnania frekvencie na 500 kHz (spodny prah)
						bsf		Dorovnanie_na_500kHz
			preskoc_spodny_prah



				;Ak bol dosiahnuty spodny prah 500 kHz.....
			btfss	Spodny_prah
			goto	preskoc_kurzor_na_nizich_radoch
				movlw	.5
				movwf	POCET_BCD
				opakuj_pocun_cislic
						;...a zaroven je kurzor na jednej z nizsich cislic, ako su stovky kHz,...
					movlw	.1
					subwf	POCET_BCD,w
					subwf	VYBER_RADU_FREKVENCIE,w	
					btfss	STATUS,Z
					goto	preskoc_kurzor_1kHz
							;...povol moznost zmeny cislic nadol...
						bcf		Spodny_prah
						movf	POCET_BCD,w
						sublw	.6				;6 - pocet bcd
						movwf	POCET
							;...a zaroven kontroluj, ci cislice od stoviek kHz po polohu kurzora nie su nulove.
						movlw	Adr_H_BCD_cisla
						movwf	FSR0H
						movlw	Adr_L_BCD_cisla+4
						movwf	FSR0L
					opakuj_test_nul
						movf	INDF0,w
						btfss	STATUS,Z
						goto	preskoc_kurzor_1kHz
						decf	FSR0L,f
						;...Ak su nulove, nedovol aktualnej cislici (kde je kurzor), zist pod 0
					decfsz	POCET,f
					goto	opakuj_test_nul
								;...nastav priznakovy bit spodneho prahu, tj blokadu uberania hodnoty
							bsf		Spodny_prah
					preskoc_kurzor_1kHz
				decfsz	POCET_BCD
				goto	opakuj_pocun_cislic
			preskoc_kurzor_na_nizich_radoch



				;Ak su desiatky MHz nulove,....
			movlw	.1
			subwf	ZACIATOK_LCD,w
			btfss	STATUS,Z
			goto	preskoc_desiatky_MHz
					;...a zaroven je kurzor na desiatkach MHz...
				movlw	.7
				subwf	VYBER_RADU_FREKVENCIE,w		;if RAAD - 5 < 0 then C=0
				btfss	STATUS,Z
				goto	preskoc_desiatky_MHz
						;...vtedy nastav stavovy bit blokujuci uberanie frekvencie
					bsf		Spodny_prah
			preskoc_desiatky_MHz



				;Ak su jednotky MHz nulove,....
			movlw	.2
			subwf	ZACIATOK_LCD,w
			btfss	STATUS,Z
			goto	preskoc_jednotky_MHz
					;...a zaroven je kurzor na desiatkach MHz...
				movlw	.6
				subwf	VYBER_RADU_FREKVENCIE,w		;if RAAD - 5 < 0 then C=0
				btfss	STATUS,Z
				goto	preskoc_jednotky_MHz
						;...vtedy nastav stavovy bit blokujuci uberanie frekvencie
					bsf		Spodny_prah
			preskoc_jednotky_MHz

	return










Prevod_BCD_na_registre_Si5351A
			;Vycistenie pamatoveho priestoru pre vypocty
		call	vycistenie_GPR_banky_2
		call	vycistenie_GPR_banky_3
		call	vycistenie_GPR_banky_4

			;Premena frekvencie zadanej v BCD na HEX cislo a jeho prepocet na cisla do registrov pre modul Si5351A
		pagesel	Vypocet_frekvencie
		call	Vypocet_frekvencie
		;call	Vykalkulovanie_BCD_cisla
		banksel	PORTA
		pagesel	nastavenie_PIC
	return






	;Podprofram pre obsluhu prerusenia. Aktualizacia frekvencie v module i na displeji
Aplikuj_frekvenciu


	; -----------------------------------APLIKOVANIE ZMENEJ FREKVENCIE---------------------------------------

				;Zapnutie timera na odpocitavanie ulozenia dat do EEPROM
			bsf		T1CON,TMR1ON

				;Vycistenie pamatoveho priestoru pre vypocty
;			call	vycistenie_GPR_banky_2
;			call	vycistenie_GPR_banky_3
;			call	vycistenie_GPR_banky_4
	
				;Premena frekvencie zadanej v BCD na HEX cislo a jeho prepocet na cisla do registrov pre modul Si5351A
			pagesel	Vypocet_frekvencie
;			call	Vypocet_frekvencie
				;Vlozenie cisel frekvencie do registrov modulu Si5351A
			call	Frekvencia_na_vystupe_0
			call	Frekvencia_na_vystupe_2
			banksel	PORTA
			pagesel	nastavenie_PIC


	
	; ------------------------------------VYPIS FREKVENCIE NA LCD-----------------------------------------------------

				;Vynechanie zobrazovania nul od najvyssieho radu BCD cisel frekvencie.
			clrf	ZACIATOK_LCD
			movlw	Adr_H_BCD_cisla
			movwf	FSR0H
			movlw	Adr_L_BCD_cisla+7
			movwf	FSR0L
				;Postupna kontrola nul od najvyssich radov. 
				;Cyklus sa opusti akonahle narazi na nenulovu cislicu.
			movlw	.7
			movwf	POCET
			opakuj_posun_zobrazovania2
				movf	INDF0,w
				btfss	STATUS,Z
				goto	preskoc_posun_zobrazovania2
					incf	ZACIATOK_LCD,f
					decf	FSR0L,f
			decfsz	POCET
			goto	opakuj_posun_zobrazovania2
			preskoc_posun_zobrazovania2
				;Frekvencia v Hz zobrazena na LCD displej (jeden register = jedna cislica)
			movlw	Adr_H_BCD_cisla
			movwf	FSR0H
			movf	ZACIATOK_LCD,w		;Posun v pamati na prvu nenulovu cislicu najvyssieho radu frekvencie
			sublw	Adr_L_BCD_cisla+7
			movwf	FSR0L
				;Nastavenie ukazatela na poziciu LCD, kde je prva nenulova cislica najvyssieho radu frekvencie.
			movf	ZACIATOK_LCD,w
			call	riadok_1_LCD
				;Premazanie predoslych miest od zaciatku riadka LCD
			movf	ZACIATOK_LCD,w
			call	zmaz_zvysok_riadku_1_LCD
				;Znizenie poctu zobrazovanzch cislic o nulove cleny od najvyssieho radu.
			movf	ZACIATOK_LCD,w
			sublw	.8
			movwf	POCET
				;Nacitanie hodnot BCD cislic frekvencie na LCD displej = zobrazenie tych cislic.
			opakuj_zobrazovanie_LCD2
				movf	INDF0,w
				addlw 	'0'
				call	LCD_ZAPIS_4bit
					decf	FSR0L
			decfsz	POCET
			goto	opakuj_zobrazovanie_LCD2
			
				;Nastavenie kurzora na poziciu, ktora sa bude menit
			movf	VYBER_RADU_FREKVENCIE,w
			sublw	.7
			call	riadok_1_LCD



		; ------------------------------------------KONTROLA cez UART-----------------------------------------------------
	#ifdef K
				;zobrazenie BCD cislic frekvencie cez UART v okne PC programu (8 bajtov)
;			movlw	Adr_H_BCD_cisla
			movlw	0x01
			movwf	FSR0H
;			movlw	Adr_L_BCD_cisla + 7
			movlw	0x20 + 5*8 + 7
			movwf	FSR0L
			movlw	.8
			movwf	TMP_UART
			opakuj_TX_UART
				movf	INDF0,w
				call	USART_TXW
				decf	FSR0L
			decfsz	TMP_UART
			goto	opakuj_TX_UART
	#endif

	return





Ulozenie_udajov_do_EEPROM
			;Ulozenie frekvencie.
		movlw	Adr_H_BCD_cisla
		movwf	FSR0H
		movlw	Adr_L_BCD_cisla
		movwf	FSR0L
		movlw	.8
		movwf	POCET
		opakuj_zapis_eeprom
			movf	POCET,w
			movwf	ADRESA_EEPROM
			movf	INDF0,w
			call	WRITE_EPROM
			incf	FSR0L,f
		decfsz	POCET
		goto	opakuj_zapis_eeprom
			;Ulozenie ladiaceho kroku
		movlw	0x00
		movwf	ADRESA_EEPROM
		movf	VYBER_RADU_FREKVENCIE,w
		call	WRITE_EPROM
	
	return




;**************************************************************************************************
;************************************ OBSLUHA PRERUSENIA ******************************************
;**************************************************************************************************

prerusenie
			;Vypnutie vsetkych preruseni	
		bcf		INTCON,GIE

	; ----------------------------------UKLADANIE UDAJOV DO EEPROM---------------------------------

				;Obsluha timera pre ulozenie dat do EEPROM po urcitom casovom intervale, ked nastala zmena frekvencie
			btfss	PIR1,TMR1IF
			goto	preskoc_ulozenie_dat
				clrf	PIR1
				incf	CNT_TMR1,f
				;call	LCD_LED_VYP
				clrf	PIR1
					;Nastavenie casu. Pocet prerusenii vyvolanych pretecenim TMR1. 
					;Jedno pretecenie = 4*256*256*8/Fosc(32MHz) = 0,065536s
				movlw 	.61				; 4 sekundy
				;movlw 	.107			; 7 sekund
				subwf	CNT_TMR1,w
				btfss	STATUS,Z
				goto	preskoc_ulozenie_dat
					bcf		T1CON,TMR1ON
					clrf	CNT_TMR1
					call	Ulozenie_udajov_do_EEPROM
					;call	LCD_LED_ZAP
			preskoc_ulozenie_dat
	


	; ---------------------------OBSLUHA TLACITIEK VOLBY KROKU-----------------------------


				;Zmena ladiaceho kroku frekvencie DOLE, tlacitkom do kruhu.
			banksel  IOCBF
			btfss	IOCBF,IOCBF1
			goto	preskoc_TL_zmenu_kroku_DN
			banksel  PORTA
					;inkrementuj polohu kurzora a ladiaceho kroku
				decf	VYBER_RADU_FREKVENCIE,f
					;Ked dosiahne kurzor zaciatok, objavi sa na konci
				movf	VYBER_RADU_FREKVENCIE,w
				sublw	.255
				btfss	STATUS,Z
				goto	preskoc_prechod_na_koniec
					movlw	.7
					movwf	VYBER_RADU_FREKVENCIE
				preskoc_prechod_na_koniec
					;Nastavenie kurzora na poziciu, ktora sa bude menit
				movf	VYBER_RADU_FREKVENCIE,w
				sublw	.7
				call	riadok_1_LCD

				call	pauza_10ms

				btfss	TLAC_DN
				goto	$-1
				;call	pauza_100us	;ooooo
				call	pauza_10ms
					;Zapnutie timera na odpocitavanie ulozenia dat do EEPROM
				bsf		T1CON,TMR1ON
				;Vymazanie priznakovych bitov prerusenia od portov
			banksel  IOCBF
			clrf	IOCBF
			banksel  PORTA
			bcf		INTCON,IOCIF
			preskoc_TL_zmenu_kroku_DN
			banksel  PORTA




				;Zmena ladiaceho kroku frekvencie HORE, tlacitkom do kruhu.
			banksel  IOCBF
			btfss	IOCBF,IOCBF0	
			goto	preskoc_TL_zmenu_kroku_UP
			banksel  PORTA
					;inkrementuj polohu kurzora a ladiaceho kroku
				incf	VYBER_RADU_FREKVENCIE,f
					;Ked dosiahne kurzor koniec, objavi sa na zaciatku.
				movf	VYBER_RADU_FREKVENCIE,w
				sublw	.8
				btfsc	STATUS,Z
				clrf	VYBER_RADU_FREKVENCIE
					;Nastavenie kurzora na poziciu, ktora sa bude menit
				movf	VYBER_RADU_FREKVENCIE,w
				sublw	.7
				call	riadok_1_LCD

				call	pauza_10ms

				btfss	TLAC_UP
				goto	$-1
				;call	pauza_100us
				call	pauza_10ms
					;Zapnutie timera na odpocitavanie ulozenia dat do EEPROM
				bsf		T1CON,TMR1ON
				;Vymazanie priznakovych bitov prerusenia od portov
			banksel  IOCBF
			clrf	IOCBF
			banksel  PORTA
			bcf		INTCON,IOCIF
			preskoc_TL_zmenu_kroku_UP
			banksel  PORTA


	; ---------------------------OBSLUHA INKREMENTALNEHO POTENCIOMETRA-----------------------------






				;Pridavanie hodnoty registrov frekvencie
			banksel  IOCBF
			btfss	IOCBF,IOCBF3		;prerusenie od zapnutia A
			goto	preskoc_EN_right
			banksel  PORTA
					;Testovanie postupnosti impulzov pri otacani vpravo...
					;...a zaroven opustenie podprogramu pri otacani vlavo.
								;A je zapnute
				btfss	EN_B	;ak je B zapnute, vyskoc z pridavania hodnoty
				goto	preskoc_ladenie

				movlw	Hodnota_wdt_inkrementalu
				movwf	WDT_0
				movwf	WDT_1
		wd1		decf	WDT_0,f				;watchdog uviaznutia v slucke
				movf	WDT_0,w
				btfsc	STATUS,Z
				decf	WDT_1,f
				movf	WDT_1,w
				btfsc	STATUS,Z
				goto	preskoc_ladenie
				btfsc	EN_B				;caka na zapnutie B
				goto	wd1

				btfsc	EN_A				;ak je A vypnute, vyskoc z pridavania hodnoty
				goto	preskoc_ladenie

				movlw	Hodnota_wdt_inkrementalu
				movwf	WDT_0
				movwf	WDT_1
		wd2		decf	WDT_0,f
				movf	WDT_0,w
				btfsc	STATUS,Z
				decf	WDT_1,f
				movf	WDT_1,w
				btfsc	STATUS,Z
				goto	preskoc_ladenie
				btfss	EN_A	;caka na vypnutie A
				goto	wd2

				btfsc	EN_B	;ak je B vypnute, vyskoc z pridavania hodnoty
				goto	preskoc_ladenie

				movlw	Hodnota_wdt_inkrementalu
				movwf	WDT_0
				movwf	WDT_1
		wd3		decf	WDT_0,f
				movf	WDT_0,w
				btfsc	STATUS,Z
				decf	WDT_1,f
				movf	WDT_1,w
				btfsc	STATUS,Z
				goto	preskoc_ladenie
				btfss	EN_B	;caka na vypnutie B
				goto	wd3

					;Vyhodnotenie dosiahnutia dolnej hranice frekvencie.
				call	vyhodnotenie_horneho_prahu


				btfsc	Vrchny_prah
				goto	preskoc_EN_right


					;Frekvencia v Hz zobrazena na LCD displej (jeden register = jedna cislica)
				movlw	Adr_H_BCD_cisla
				movwf	FSR0H
				movlw	Adr_L_BCD_cisla	;(+ 8 bajtov BCD cisla frekvencie. Nulty bajt je najnizsi.)
				addwf	VYBER_RADU_FREKVENCIE,w
				movwf	FSR0L
					;inkrementacia vybraneho ciselneho radu frekvencie
				incf	INDF0,f
					;Spristupnenie hodnoty aktualnej BCD cislice na globalnej urovni
				movf	INDF0,w
				movwf	HODNOTA_BCD
				banksel  IOCBF
				clrf	IOCBF
				banksel	PORTA
					;Vykonanie zmeny frekvencie vratane vypisu na displej
				call	Prevod_BCD_na_registre_Si5351A
				call	Aplikuj_frekvenciu
				goto	preskoc_ladenie
			preskoc_EN_right
			banksel  PORTA






				;Uberanie hodnoty registrov frekvencie
			banksel  IOCBF
			btfss	IOCBF,IOCBF2
			goto	preskoc_EN_left
			banksel  PORTA
					;Testovanie postupnosti impulzov pri otacani vlavo...
					;...a zaroven opustenie podprogramu pri otacani vpravo.
								;B je zapnute
				btfss	EN_A	;ak je A zapnute, vyskoc z pridavania hodnoty
				goto	preskoc_ladenie

				movlw	Hodnota_wdt_inkrementalu
				movwf	WDT_0
				movwf	WDT_1
		wd4		decf	WDT_0,f				;watchdog uviaznutia v slucke
				movf	WDT_0,w
				btfsc	STATUS,Z
				decf	WDT_1,f
				movf	WDT_1,w
				btfsc	STATUS,Z
				goto	preskoc_ladenie
				btfsc	EN_A				;caka na zapnutie A
				goto	wd4

				btfsc	EN_B				;ak je A vypnute, vyskoc z pridavania hodnoty
				goto	preskoc_ladenie

				movlw	Hodnota_wdt_inkrementalu
				movwf	WDT_0
				movwf	WDT_1
		wd5		decf	WDT_0,f				;watchdog uviaznutia v slucke
				movf	WDT_0,w
				btfsc	STATUS,Z
				decf	WDT_1,f
				movf	WDT_1,w
				btfsc	STATUS,Z
				goto	preskoc_ladenie
				btfss	EN_B				;caka na vypnutie B
				goto	wd5

				btfsc	EN_A	;ak je A vypnute, vyskoc z pridavania hodnoty
				goto	preskoc_ladenie

				movlw	Hodnota_wdt_inkrementalu
				movwf	WDT_0
				movwf	WDT_1
		wd6		decf	WDT_0,f				;watchdog uviaznutia v slucke
				movf	WDT_0,w
				btfsc	STATUS,Z
				decf	WDT_1,f
				movf	WDT_1,w
				btfsc	STATUS,Z
				goto	preskoc_ladenie
				btfss	EN_A				;caka na vypnutie A
				goto	wd6

					;Vyhodnotenie dosiahnutia dolnej hranice frekvencie.
				call	vyhodnotenie_dolneho_prahu

					;stavovy  bit dosiahnuteho dolneho prahu preskakuje uberanie hodnoty frekvencie
				btfsc	Spodny_prah
				goto	preskoc_uberanie_hodnoty
						;Frekvencia v Hz zobrazena na LCD displej (jeden register = jedna cislica)
					movlw	Adr_H_BCD_cisla
					movwf	FSR0H
					movlw	Adr_L_BCD_cisla	;(+ 8 bajtov BCD cisla frekvencie. Nulty bajt je najnizsi.)
					addwf	VYBER_RADU_FREKVENCIE,w
					movwf	FSR0L
						;dekrementacia vybraneho ciselneho radu frekvencie				
					decf	INDF0,f
						;Spristupnenie hodnoty aktualnej BCD cislice na globalnej urovni
					movf	INDF0,w
					movwf	HODNOTA_BCD
					banksel  IOCBF
					clrf	IOCBF
					banksel	PORTA
						;Vykonanie zmeny frekvencie vratane vypisu na displej
					call	Prevod_BCD_na_registre_Si5351A
				preskoc_uberanie_hodnoty
				call	vyhodnotenie_dolneho_prahu
					;Dorovnanie frekvencie na 500kHz, ak su jednotky a desiatky MHz nulove a bola tam nizsia hodnota.
				btfss	Dorovnanie_na_500kHz
				goto	preskoc_nastavenie_5xx_kHz
						;...a vloz na poziciu stoviek kHz cislo 5.
					movlw	Adr_H_BCD_cisla
					movwf	FSR0H
					movlw	Adr_L_BCD_cisla+5
					movwf	FSR0L
					movlw	.5
					movwf	INDF0
					decf	FSR0L,f
					movlw	.5
					movwf	POCET
					opakuj_vynulovanie
						clrf	INDF0
						decf	FSR0L,f
					decfsz	POCET
					goto	opakuj_vynulovanie
						;Vykonanie zmeny frekvencie vratane vypisu na displej
					call	Prevod_BCD_na_registre_Si5351A
				preskoc_nastavenie_5xx_kHz
				call	Aplikuj_frekvenciu

			preskoc_EN_left
			banksel  PORTA

			preskoc_ladenie

				;Vymazanie priznakovych bitov prerusenia od portov
			banksel  IOCBF
			clrf	IOCBF
			banksel  PORTA
			bcf		INTCON,IOCIF



			;Zapnutie preruseni
		bsf		INTCON,GIE	

	RETFIE




;***********************************************************************************************
;************************************* HLAVNY PROGRAM ******************************************
;***********************************************************************************************


START


		call	nastavenie_PIC	
			;Cakanie na bezpecne zapnutie PIC obvodu.
		movlw	.1
		call	pauza



	;*******************************************************************************************************
	;**************************************** Frekvencia zadana v BCD **************************************
	;******************************************** Minimum 500 kHz *******************************************
	;*******************************************************************************************************

			;Nacitanie frekvencie a ladiaceho kroku z pamati programu v pripade, ze pamat EEPROM je vyresetovana.
		movlw	0x00
		call	READ_EPROM
		sublw	0xFF
		btfss	STATUS,Z
		goto	preskoc_init_frekvencie		
				;Frekvencia v Hz zobrazena na LCD displej (jeden register = jedna cislica)
			movlw	Adr_H_BCD_cisla
			movwf	FSR0H
			movlw	Adr_L_BCD_cisla
			movwf	FSR0L
			movlw	.0
			movwf	INDF0
				incf	FSR0L
			movlw	.0
			movwf	INDF0
				incf	FSR0L
			movlw	.0
			movwf	INDF0
				incf	FSR0L
			movlw	.0
			movwf	INDF0
				incf	FSR0L
			movlw	.0
			movwf	INDF0
				incf	FSR0L
			movlw	.0
			movwf	INDF0
				incf	FSR0L
			movlw	.4
			movwf	INDF0
				incf	FSR0L
			movlw	.1
			movwf	INDF0
				;Vyber, ktory rad (register) cisla frekvencie sa ma menit. 1, 10, 100 Hz, kHz, MHz
			movlw	krok_ladenia_frekvencie
			movwf	VYBER_RADU_FREKVENCIE
				;Ulozenie defaultnych udajov do EEPROM
			call	Ulozenie_udajov_do_EEPROM
		preskoc_init_frekvencie



			;Nacitanie frekvencie z EEPROM
		movlw	Adr_H_BCD_cisla
		movwf	FSR0H
		movlw	Adr_L_BCD_cisla
		movwf	FSR0L
		movlw	.8
		movwf	POCET
		opakuj_citanie_eeprom
			movf	POCET,w
			call	READ_EPROM
			movwf	INDF0
			incf	FSR0L,f
		decfsz	POCET
		goto	opakuj_citanie_eeprom
			;Nacitanie ladiaceho kroku z EEPROM
		movlw	0x00
		call	READ_EPROM
		movwf	VYBER_RADU_FREKVENCIE
;		decf	VYBER_RADU_FREKVENCIE,f



			;Premena frekvencie zadanej v BCD na HEX cislo a jeho prepocet na cisla do registrov pre modul Si5351A
		pagesel	Vypocet_frekvencie
		call	Vypocet_frekvencie
			;Nastavenie prvotnych parametrov modulu Si5351A + rozhodenie vysledkov frekvencie do registrov modulu
		call	Prvotne_nastavenie_SI5351A
;		call	Vykalkulovanie_BCD_cisla
		banksel	PORTA
		pagesel	nastavenie_PIC

			;Vynechanie zobrazovania nul od najvyssieho radu BCD cisel frekvencie.
		clrf	ZACIATOK_LCD
		movlw	Adr_H_BCD_cisla
		movwf	FSR0H
		movlw	Adr_L_BCD_cisla+7
		movwf	FSR0L
			;Postupna kontrola nul od najvyssich radov. 
			;Cyklus sa opusti akonahle narazi na nenulovu cislicu.
		movlw	.7
		movwf	POCET
		opakuj_posun_zobrazovania
			movf	INDF0,w
			btfss	STATUS,Z
			goto	preskoc_posun_zobrazovania
				incf	ZACIATOK_LCD,f
				decf	FSR0L,f
		decfsz	POCET
		goto	opakuj_posun_zobrazovania
		preskoc_posun_zobrazovania

			;inicializacia LCD displeja
		call	INIT_DISPLEJ_ST7066

			;Frekvencia v Hz zobrazena na LCD displej (jeden register = jedna cislica)
		movlw	Adr_H_BCD_cisla
		movwf	FSR0H
		movf	ZACIATOK_LCD,w		;Posun v pamati na prvu nenulovu cislicu najvyssieho radu frekvencie
		sublw	Adr_L_BCD_cisla+7
		movwf	FSR0L
			;Nastavenie ukazatela na poziciu LCD, kde je prva nenulova cislica najvyssieho radu frekvencie.
		movf	ZACIATOK_LCD,w
		call	riadok_1_LCD
			;Premazanie predoslych miest od zaciatku riadka LCD
		movf	ZACIATOK_LCD,w
		call	zmaz_zvysok_riadku_1_LCD
			;Znizenie poctu zobrazovanzch cislic o nulove cleny od najvyssieho radu.
		movf	ZACIATOK_LCD,w
		sublw	.8
		movwf	POCET
			;Nacitanie hodnot BCD cislic frekvencie na LCD displej = zobrazenie tych cislic.
		opakuj_zobrazovanie_LCD
			movf	INDF0,w
			addlw 	'0'
			call	LCD_ZAPIS_4bit
				decf	FSR0L
		decfsz	POCET
		goto	opakuj_zobrazovanie_LCD
			
			;Napis "MHz" na druhom riadku LCD displeja
		movlw	.3
		call	riadok_2_LCD
;		movlw 	'M'
;		call	LCD_ZAPIS_4bit
		movlw 	'H'
		call	LCD_ZAPIS_4bit
		movlw 	'z'
		call	LCD_ZAPIS_4bit

			;Nastavenie kurzora na poziciu (cislicu frekvencie = ladiaci krok),ktora sa bude menit.
		movf	VYBER_RADU_FREKVENCIE,w
		sublw	.7
		call	riadok_1_LCD

			;vymazanie vsetkych priznakov prerusenia pouzivanych v programe
		banksel	IOCBF
		clrf	IOCBF
		banksel	PORTA
		clrf	PIR1









;ooooo

#ifdef k

	pagesel	Vykalkulovanie_BCD_cisla


		call	_C
		call	_Q

		call	medzera_slova

		call	_C
		call	_Q

		call	medzera_slova

		call	_C
		call	_Q

		call	medzera_slova

		call	_D
		call	_E

		call	medzera_slova

		call	_O
		call	_M
		call	_3
		call	_T
		call	_L
		call	_G

		call	medzera_slova

		call	_O
		call	_M
		call	_3
		call	_T
		call	_L
		call	_G

;		call	medzera_slova

;		call	_O
;		call	_M
;		call	_3
;		call	_T
;		call	_L
;		call	_G

		call	medzera_slova

		call	_P
		call	_S
		call	_E

		call	medzera_slova

		call	_K

		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova


		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova


	pagesel	nastavenie_PIC


#endif







		;zapnutie vsetkych preruseni
	bsf		INTCON,GIE



opakuj	

;ooooo
;#ifdef k

	btfss	Jednorazovo_zapni
	goto	preskoc_CLK0_zap
	btfss	TL
	goto	preskoc_CLK0_zap
		bcf		Jednorazovo_zapni
		pagesel	Vykalkulovanie_BCD_cisla
		call	CLK0_zap
	pagesel	nastavenie_PIC
	preskoc_CLK0_zap




	btfsc	TL
	goto	preskoc_majak
		bsf		Jednorazovo_zapni
		pagesel	Vykalkulovanie_BCD_cisla

		call	_C
		call	_K

		call	medzera_slova



#ifdef k

		call	_C
		call	_Q

		call	medzera_slova

		call	_C
		call	_Q

		call	medzera_slova

		call	_C
		call	_Q

		call	medzera_slova

		call	_C
		call	_Q

		call	medzera_slova

		call	_D
		call	_E

		call	medzera_slova

		call	_O
		call	_M
		call	_3
		call	_T
		call	_L
		call	_G

		call	medzera_slova

		call	_O
		call	_M
		call	_3
		call	_T
		call	_L
		call	_G

;		call	medzera_slova

;		call	_O
;		call	_M
;		call	_3
;		call	_T
;		call	_L
;		call	_G

		call	medzera_slova

		call	_P
		call	_S
		call	_E

		call	medzera_slova

		call	_K

		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova


		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova
		call	medzera_slova

#endif

	pagesel	nastavenie_PIC
	bsf		INTCON,GIE

	preskoc_majak

;#endif







		nop
		clrwdt
		nop

	goto 	opakuj















;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;******************************** STRANKA 1 PAMATI PROGRAMU *********************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************
;********************************************************************************************************

										ORG		0800h

;#ifdef k
						;-----------------------------------;
						;	Banka		Adresa		Dlzka	;
						;-----------------------------------;
						;	BANK 1		0x00A0		80 B	;
						;	BANK 2		0x0120		80 B	;
						;	BANK 3		0x01A0		80 B	;
						;	BANK 4		0x0220		48 B	;
						;-----------------------------------;

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!! PREMENNE sub2, sub1, subsub1, subsub2, subsubsub, subsubsubsub, pp1 a pp2....!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!! ...potrebuju dvojnasobok pamete, nez je ich dlzka, pretoze v tom priestore...!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!! ...prebiehaju vypocty (pre delenie a nasobenie). !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


		;Adresy odcitania------------------------------------BANK 2---------------------
	#define		dlzka_cisla						.8
	#define		Dlzka_rozdielu					.8
	#define		Dlzka_scitanca					.8
	#define		Adr_H_pp1						0x01	
	#define		Adr_L_pp1						0x20
		; 16 bajtov
	#define		Adr_H_pp2						0x01	
	#define		Adr_L_pp2						0x20 + 2*dlzka_cisla
		;+16 bajtov
	#define		Adr_H_mensitel					0x01	
	#define		Adr_L_mensitel					0x20 + 4*dlzka_cisla
		;+8 bajtov
		;Adresy skonvertovaneho BCD na HEX
	#define		Adr_H_nasobiaceho_radu			0x01
	#define		Adr_L_nasobiaceho_radu			0x20 + 5*dlzka_cisla; + Pocet_cislic
		;+4 bajty
	#define		Adr_H_BCD_na_HEX				0x01
	#define		Adr_L_BCD_na_HEX				0x20 + 5*dlzka_cisla + .4 ; + Pocet_cislic + .4
		;+4 bajty
		;=48 bajtova obsadenost



		;Adresy nasobenia ------------------------------------BANK 3---------------------
	#define		Adr_H_subsub1					0x01
	#define		Adr_L_subsub1					0xA0+2		;vypocet potrebuje 2 nasobnu dlzku pamate "dlzky_cisla"
		; +2+16 registrov = 18
	#define		Adr_H_subsub2					0x01
	#define		Adr_L_subsub2					0xA0+2 + 1*(2*dlzka_cisla)
		; +16 registrov = 34
	#define		Adr_H_subsubsub					0x01
	#define		Adr_L_subsubsub					0xA0+2 + 2*(2*dlzka_cisla)
		; +16 registrov = 50
	#define		Adr_H_subsubsubsub				0x01
	#define		Adr_L_subsubsubsub				0xA0+2 + 3*(2*dlzka_cisla)
		; +16 registrov
		;=66 bajtova obsadenost


		;Adresy vysledkov delenia pre modul ------------------BANK 4---------------------
	#define		Dlzka_delenca					.8
	#define		Adr_H_sub2						0x02	
	#define		Adr_L_sub2						0x20
		; +18 registrov
	#define		Adr_H_sub1						0x02	
	#define		Adr_L_sub1						0x20 + 1*(2*Dlzka_delenca+2)
		; +18 registrov = 36
	#define		Adr_H_delitel					0x02	
	#define		Adr_L_delitel					0x20 + 2*(2*Dlzka_delenca+2)
		; +8 registrov
		;=44 bajtova obsadenost (maximum je 48 registrov)



		;Adresa modulu Si5351A
	#define SI5351_ADDRESS 0xC0 ; 0b11000000
	
		;Adresy registrov modulu Si5351A
	#define CLK_ENABLE_CONTROL       .3
	#define PLLX_SRC				.15
	#define CLK0_CONTROL            .16 
	#define CLK1_CONTROL            .17
	#define CLK2_CONTROL            .18
	#define SYNTH_PLL_A             .26
	#define SYNTH_PLL_B             .34
	#define SYNTH_MS_0              .42
	#define SYNTH_MS_1              .50
	#define SYNTH_MS_2              .58
	#define PLL_RESET              .177
	#define XTAL_LOAD_CAP          .183

;oooo



		;Premenne v banke 1
	CBLOCK		0xA0+Pocet_cislic
		POCET_MIEST
		ADRESA_H_DELENCA_A_VYSLEDKU
		ADRESA_L_DELENCA_A_VYSLEDKU
		ADRESA_H_DELITELA
		ADRESA_L_DELITELA
		TMP
		TMP_TMP
		POSUN_V_DELITELI
		DLZKA_DELITELA
		POCET_VNORENI
		POCET_BAJTOV_DELITELA
		AKTUALNY_BAJT_DELITELA
		SWR_bank1
		POCET_REGISTROV
		POSUN_NASOBITELA
		POCET_BYTE_NASOBITELA
		ADRESA_H_NASOBITELA
		ADRESA_L_NASOBITELA
		ADRESA_H_NASOBENEHO_CISLA
		ADRESA_L_NASOBENEHO_CISLA
		POCET_KRAT
		ZVYSOK_REGISTROV
		ADRESA_H_SCITANEC
		ADRESA_L_SCITANEC
		ADRESA_H_SCITANEC_A_VYSLEDOK
		ADRESA_L_SCITANEC_A_VYSLEDOK
		ADRESA_H_MENSITEL
		ADRESA_L_MENSITEL
		ADRESA_H_MENSENEC
		ADRESA_L_MENSENEC
		DLZKA_ROZDIELU				
		BAJTY_NA_DEKREMENTACIU		
		TMP1
		TMP2
		RAD
		NASOBITEL
		TMP_Si5351
		ADRESA_REG_SI5351A
	ENDC


	#define		Odpocet_povoleny		SWR_bank1,0
	#define		Pripocitanie_povolene	SWR_bank1,1




;**************************************************************************************************
;************************** 32 BITOVA MATEMATIKA pre zobrazenie na LCD ****************************
;**************************************************************************************************

; Existuje 10 registrov, kazdy pre jednu cislicu od 0 do 9. Nasobi sa to tak, ze X krat pripocitavam.....
;...vlastnu hodnotu kazdej cislice. Po kazdom jednom pripocitani vsetkych cislic (registrov) sa skontroluje,....
; ci nedoslo k presiahnutiu hodnoty 9. Ak ano, tak zostatkova hodnota "cislo-10" sa vrati do registra a dalsi...
; register, o rad vysii, sa inkrementuje o 1. Najvacsie pripocitanie, ku ktoremu moze dojst pri jednej cislici...
;...(registri) je 9+9=18. Tak sa vypocita 18-10=8, cislo 8 sa vrati do registra a register o rad vyssi sa....
;...inkrementuje o 1. Tak vynikne sucislie 01 08. (Ten vyssi sa nasledne kontroluje tymto istym procesom.)
;Mozno v tom vyssom registri bolo pred tym cislo 9 a po pripocitani sebou samym vyniklo 18. Vysledne sucislie...
;...potom vyzera takto: 19 08 (lebo ta jednotka sa pripocitala k 18tke). To je maximalne cislo, ktore sa moze...
;...v jednom registri objavit. ....To vsetko sa deje v podprograme "Vykalkulovanie_BCD_cisla".

Vykalkulovanie_BCD_cisla
	banksel	POCET_MIEST
				;pocet registrov na kalkulaciu
			movlw	Pocet_cislic
			movwf	POCET_REGISTROV
				;adresa prveho registra v poli
			movlw	Adr_H_BCD_cisla
			movwf	FSR0H
			movlw	Adr_L_BCD_cisla
			movwf	FSR0L
		opakuj_kalkulaciu
				;pretecenie pod 0 sposobi dekrementaciu
			movlw	.245
			subwf	INDF0,w			;cislo - 245
			btfss	STATUS,C		
			goto	preskoc_RR2
					;vypocitanie zostatkovej hodnoty po preteceni.
				movlw	.246			
				subwf	INDF0,f		;cislo-246=zostatkova hodnota, spat do registra.>>>
				incf	FSR0L,f
					;ked sa dosiahne posledny register, nesmie sa inkrementovat dalsi,....
					;...lebo by sa pristupovalo uz mimo pole.
				movlw	.1
				subwf	POCET_REGISTROV,w
				btfss	STATUS,Z
					decf	INDF0,f		;>>>inkrementuj o 1 dalsi register = hodnotu cislice s vyssim radom...
				decf	FSR0L,f			;...a vrat sa spat.
			preskoc_RR2



				;pretecenie nad 9 sposobi inkrementaciu dalsieho registra a zobrazenie zostatkovej hodnoty.
			movf	INDF0,w
			sublw	.9				;9-cislo > if(-)then C=0
			btfsc	STATUS,C		;test pretecenia.
			goto	preskoc_RR
					;vypocitanie zostatkovej hodnoty po preteceni.
				movlw	.10			
				subwf	INDF0,f		;cislo-10=zostatkova hodnota, spat do registra.>>>
				incf	FSR0L,f

				incf	INDF0,f		;>>>inkrementuj o 1 dalsi register = hodnotu cislice s vyssim radom...
					;ked sa dosiahne posledny register, nesmie sa inkrementovat dalsi,....
					;...lebo by sa pristupovalo uz mimo pole.
				movlw	.1
				subwf	POCET_REGISTROV,w
				btfss	STATUS,Z
				goto	preskoc_ochranu_pola
					decf	INDF0,f
					banksel	SWR
					bsf		Pretecenie_nastalo
					banksel	POCET_MIEST
				preskoc_ochranu_pola

				decf	FSR0L,f			;...a vrat sa spat.

			preskoc_RR
			incf	FSR0L,f					;posun na dalsiu cislicu (register)
			decfsz	POCET_REGISTROV,f
			goto	opakuj_kalkulaciu
;	banksel	PORTA
	return





Prevod_BCD_na_HEX
	banksel	POCET_MIEST
			movlw	Pocet_cislic		;pocet cislic BCD
			movwf	TMP2
			clrf	RAD
		opakuj_posun_BCD
			movlw	Adr_H_BCD_cisla
			movwf	FSR0H
			movlw	Adr_L_BCD_cisla
			addwf	RAD,w
			movwf	FSR0L
			movf	INDF0,w
			movwf	NASOBITEL
				;pocet registrov vysledku (hex)
			movlw	.4
			movwf	TMP
				;adresa prveho registra v poli
			movlw	Adr_H_nasobiaceho_radu
			movwf	FSR0H
			movlw	Adr_L_nasobiaceho_radu
			movwf	FSR0L
			movlw	Adr_H_BCD_na_HEX
			movwf	FSR1H
			movlw	Adr_L_BCD_na_HEX
			movwf	FSR1L
			movlw	.0
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_0
				movlw	0x01		; nasobitel 10^0=1
				movwf	INDF0
			preskoc_rad_0
			movlw	.1
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_1
				movlw	0x0A		; nasobitel 10^1=10
				movwf	INDF0
			preskoc_rad_1
			movlw	.2
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_2
				movlw	0x64		; nasobitel 10^2=100
				movwf	INDF0
			preskoc_rad_2
			movlw	.3
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_3
				movlw	0xE8		; nasobitel 10^3=1000
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x03
				movwf	INDF0
				decf	FSR0L,f
			preskoc_rad_3
			movlw	.4
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_4
				movlw	0x10		; nasobitel 10^4=10000
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x27
				movwf	INDF0
				decf	FSR0L,f
			preskoc_rad_4
			movlw	.5
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_5
				movlw	0xA0		; nasobitel 10^5=100000
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x86
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x01
				movwf	INDF0
				decf	FSR0L,f
				decf	FSR0L,f
			preskoc_rad_5
			movlw	.6
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_6
				movlw	0x40		; nasobitel 10^6=1000000
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x42
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x0F
				movwf	INDF0
				decf	FSR0L,f
				decf	FSR0L,f
			preskoc_rad_6
			movlw	.7
			subwf	RAD,w
			btfss	STATUS,Z
			goto	preskoc_rad_7
				movlw	0x80		; nasobitel 10^7=10000000
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x96
				movwf	INDF0
				incf	FSR0L,f
				movlw	0x98
				movwf	INDF0
				decf	FSR0L,f
				decf	FSR0L,f
			preskoc_rad_7
			opakuj_posun_HEX
				;Hodnota nasobitela na aktualnej pozicii BCD cisla
			movf	NASOBITEL,w
			movwf	TMP1
				;V pripade nuly (nasobenia nulou) preskoc rutinu nasobenia
			btfsc	STATUS,Z				
			goto	preskoc_nasobenie
				opakuj_pripocitanie_HEX
						;Pripocitanie cisla k sebe samemu
					movf	INDF0,w
					addwf	INDF1,f			;X+=nasobitel, if (pretecenie) then C=1
						;Vyhodnot, ci register pretiekol. Ak ano, nastav flag-bit do 1, v opacnom pripade vynuluj.
					btfsc	STATUS,C
					bsf		Pripocitanie_povolene
					btfss	STATUS,C
					bcf		Pripocitanie_povolene
						;Ak register pretiekol, idu sa pripocitavat nasledujuce registre o +1.
					btfss	Pripocitanie_povolene
					goto	preskoc_100
							;Skopiruj aktualnu polohu v registroch sciitanca.
						movf	TMP,w
						movwf	ZVYSOK_REGISTROV
							;pripocitanie 1 do ostatnych registrov pokracuje dovtedy, dokedy ten predosly pretiekol.
						opakuj_inkrementaciu
							incf	FSR1L,f
							btfss	Pripocitanie_povolene
							goto	preskoc_inkrementaciu
								movlw	.1
								addwf	INDF1,f
									;akonahle sa skoncilo s preteceniami, pripocitavanie 1 do dalsich registrov sa zastavi.
								btfss	STATUS,C
								bcf		Pripocitanie_povolene
							preskoc_inkrementaciu
						decfsz	ZVYSOK_REGISTROV,f
						goto	opakuj_inkrementaciu
							;Navrat ukazatela v pamati na povodny register
						movf	TMP,w
						subwf	FSR1L,f		;FSR1L-TMP
					preskoc_100			
				decfsz	TMP1,f
				goto	opakuj_pripocitanie_HEX
			preskoc_nasobenie
			incf	FSR0L,f
			incf	FSR1L,f
			decfsz	TMP,f
			goto	opakuj_posun_HEX
		incf	RAD,f
		decfsz	TMP2,f
		goto	opakuj_posun_BCD
;	banksel	PORTA
return



;*****************************************************************************************************************
;*************************** DELENIE VIACBYTOVEHO DELENCA VIACBYTOVYM DELITELOM **********************************
;*****************************************************************************************************************

	;
	;Toto delenie pracuje na principe odpocitavania bajtov delitela od bajtov delenca az do pretecenia. Vtedy...
	;...nastane vratenie hodnoty o pretecenu ciastku a posun o 1 smerom k nizsim bajtom delenca k dalsiemu odpocitavaniu.
	;Pocitadla rozprestrete pomedzi bajty delenca pocitaju pocet odpocitani na prislusnych poziciach (vaahach) delenca.
	;-----------------------------------------------------------------------------------------------------------
	;-Adresa zaciatku bajtov delenca sa zadava do premennych ADRESA_H_DELENCA_A_VYSLEDKU a ADRESA_L_DELENCA_A_VYSLEDKU.
	;-Adresa zaciatku bajtov delitela sa zadava do premennych ADRESA_H_DELITELA a ADRESA_L_DELITELA.
	;-Pocet bajtov delenca/delitela sa zadava do symbolickej konstanty "Dlzka_delenca".
	;-Potom je mozne vlozit konkretne cisla delenca a delitela od prislusnych adries (posunom FSR a vkladanim INDF).
	;-Nenulovych bajtov delitela moze byt samozrejme menej, nez "Dlzka_delenca". Nulove sa automaticky vylucia. 
	;-Delenim nulou sa proces delenia automaticky obchadza. 
	;-Pri delenci i deliteli plati zasada, ze bajt s najnizsou adresou je najnizsi (najmenej vyznamny).
	;-Adresny priestor delenca potrebuje dvojnasobnu dlzku, lebo medzi jeho bajty su vlozene pocitadla vysledku.
	;-Vysledok sa vo finale zapise na adresy delenca - tj. priestor delenca je prepisany vysledkom (podielom).
	;
Vydelenie
	banksel	POCET_MIEST
			;Rozlozenie registrov delenca tak, aby medzi nimi bola medzera pre registre podielu (vysledku).
		movlw	Dlzka_delenca
		movwf	POCET_MIEST
;		movlw	Adr_H_sub2
		movf	ADRESA_H_DELENCA_A_VYSLEDKU,w
		movwf	FSR0H
;		movlw	Adr_L_sub2-1+2*Dlzka_delenca+2
		movlw	2*Dlzka_delenca+2-1
		subwf	ADRESA_L_DELENCA_A_VYSLEDKU,w
		movwf	FSR0L
;		movlw	Adr_L_sub2-1
		decf	ADRESA_L_DELENCA_A_VYSLEDKU,w
		movwf	FSR0L
	rozlozenie
			;presun na posledny byte delenca
		movf	POCET_MIEST,w
		addwf	FSR0L
			;skopirovanie hodnoty toho byte a vynulovanie
		movf	INDF0,w
		movwf	TMP
		clrf	INDF0
			;dalsi posun v pamati o dlzku delenca v bajtoch
		movf	POCET_MIEST,w
		addwf	FSR0L
			;vlozenie hodnoty skopirovaneho bajtu tam
		movf	TMP,w
		movwf	INDF0
			;vynulovanie nasledujucej pozicie (kvoli pripadneho obsahu v medzerach vyhradenych pre pocitadla)
		incf	FSR0L,f
		clrf	INDF0
		decf	FSR0,f
			;navrat na zaciatok
		movf	POCET_MIEST,w
		subwf	FSR0L
		subwf	FSR0L
		;znizenie nasledujuceho posunu o 1
	decfsz	POCET_MIEST
	goto	rozlozenie
			;Zistenie dlzky delitela (pocet nenulovych cislic - tj. registrov). Zacina sa od dlzky, aku ma delenec minus 1.
			;START adresy
;		movlw	Adr_H_delitel
		movf	ADRESA_H_DELITELA,w
		movwf	FSR1H
;		movlw	Adr_L_delitel + Dlzka_delenca
		movlw	Dlzka_delenca
		addwf	ADRESA_L_DELITELA,w
		movwf	FSR1L
			;Pociatocna dlzka delitela rovnaka ako delenca
		movlw	Dlzka_delenca
		movwf	DLZKA_DELITELA
		opakuj_zistovanie_dlzky
			decf	FSR1L,f
			movf	INDF1,w
			btfss	STATUS,Z
			goto	vyskoc_zo_zistovania
		decfsz	DLZKA_DELITELA,f
		goto	opakuj_zistovanie_dlzky
		vyskoc_zo_zistovania
			;****************** OSETRENIE DELENIA NULOU **********************
			;Ked ani jeden register delitela nema nenulovu hodnotu, je nulovy. Vtedy preskoc cele delenie.
		movf	DLZKA_DELITELA,w
		btfsc	STATUS,Z
		goto	preskoc_cele_delenie
	;===================================== VYPOCET DELENIA ========================================
			;Vydelenie delenca delitelom a ziskanie vysledku (podielu)
		;movlw	Dlzka_delenca - DLZKA_DELITELA + 1
		movf	DLZKA_DELITELA,w
		sublw	Dlzka_delenca + 1
		movwf	POCET_MIEST
			; adresa delenec, podiel
			;Adr. +1(p)
;		movlw	Adr_H_sub2
		movf	ADRESA_H_DELENCA_A_VYSLEDKU,w
		movwf	FSR0H
;		movlw	Adr_L_sub2 + 2*Dlzka_delenca
		movlw	2*Dlzka_delenca
		addwf	ADRESA_L_DELENCA_A_VYSLEDKU,w
		movwf	FSR0L
			;adresa delitela	
			;Adr.Dn +1
;		movlw	Adr_H_delitel
		movf	ADRESA_H_DELITELA,w
		movwf	FSR1H
;		movlw	Adr_L_delitel + DLZKA_DELITELA
		movf	DLZKA_DELITELA,w
;		addlw	Adr_L_delitel
		addwf	ADRESA_L_DELITELA,w
		movwf	FSR1L
	; Bajty delenca sa posuvaju o 2n-1 pozicii, lebo na 2n-2 poziciach su v pamati pocitadla registrov vysledku
	; Bajty delitela sa posuvaju o n-1 pozicii, lebo adresne zacinaju od 0 a n nabera hodnoty 1,2,3,4,.....
	delenie
			;Posun adries vysledku, kvoli zarovnaniu jeho cisel doprava v pamati, lebo dlhsi delitel sa posuva...
			;....o n-1 krat menej, nez ked ho tvori len jeden register. Najvyssi bajt delitela zacina odcitavanim...
			;...od najvyssieho bajtu delenca. Postupne sa posuva po delenci smerom k nizsim cislam. Konci sa, ked...
			;....sa najnizsi bajt delitela odpocitava od najnizsieho cisla delenca
		;movlw	DLZKA_DELITELA - 1
		decf	DLZKA_DELITELA,w
		movwf	TMP
		lslf	TMP,w
		subwf	FSR0L,f
			; inkrementacia registra podielu (vysledku)					 +1
		incf	INDF0,f		
			;navrat ukazatela v pamati spat.
		lslf	TMP,w
		addwf	FSR0L,f
		;movlw	DLZKA_DELITELA
		movf	DLZKA_DELITELA,w
		movwf	POCET_BAJTOV_DELITELA
		clrf	AKTUALNY_BAJT_DELITELA
		posun_bajtov_delitela
				;n = 1,2,3,....
			incf	AKTUALNY_BAJT_DELITELA,f		;n = AKTUALNY_BAJT_DELITELA				
				;posun adresy delenca o n pozicii nizsie (v pamati je to pozicia 2n-1)
			lslf	AKTUALNY_BAJT_DELITELA,w			;*2									
			subwf	FSR0L,f
			incf	FSR0L,f								;-1	
				;posun adresy delitela o n pozicii nizsie. (Bajty delitela zacinaju od nuly, preto odpocitavam 1)
			movf	AKTUALNY_BAJT_DELITELA,w		;-1	
			subwf	FSR1L,f												
				;Odpocet hodnoty registra delitela od hodnoty registra delenca
			movf	INDF1,w		
			subwf	INDF0,f	
			btfss	STATUS,C
			bsf		Odpocet_povoleny
			btfsc	STATUS,C
			bcf		Odpocet_povoleny
		;----------------------------
				;Automaticke znasobovanie vnorena registrov pri viacmiestnom deliteli
				;odpocet bajtov od aktualnej polohy bajtu delenca a delitela smerom hore, az po najvyssi bajt delenca.
			movf	AKTUALNY_BAJT_DELITELA,w
			movwf	POCET_VNORENI
			opakuj_odpocet
					;posun adries delenca hore az po najvyssi bajt
				movlw	.2	;												
				addwf	FSR0L,f	;										
					;Vyssi register sa odpocita len vtedy, ked nizsi pretiekol
				btfss	Odpocet_povoleny
				goto	preskoc_vykonanie_odpoctu
						;odpocitanie 1 od registra vyssie
					movlw	.1
					subwf	INDF0,f	
					btfss	STATUS,C
					bsf		Odpocet_povoleny
					btfsc	STATUS,C
					bcf		Odpocet_povoleny				
				preskoc_vykonanie_odpoctu
			decfsz POCET_VNORENI
			goto opakuj_odpocet
		;--------------------
				;Ak retazec dekrementacii dosiahol najvyssi register delenca (tj. boli za nim len nuly), vykonaj...
				;...vratenie hodnot bajtov delitela do aktualnych bajtov delenca od toho ktory sposobil...
				;...pretecenie, smerom vyssie - a opusti delenie. (Ten co sposobil pretecenie sa musi naspat add...
				;...pripocitat kvoli pretecenej ciastke. Ostatne pripadneee vyssie sa len vkladaju.)
			btfss	Odpocet_povoleny
			goto	preskoc_opustenie_delenia
					;Vrat do bajtu +2(Delenca) po preteceni spat nulu. (Ten musi byt vzdy nulovy.)
				incf	INDF0,f
					;Navrat ukazatela spat na adresu bajtu delenca, pred ktorym vyniklo retazove pretecenie.
				lslf	AKTUALNY_BAJT_DELITELA,w		;*2
				subwf	FSR0L,f
					;vrat hodnotu bajtu delenca ktory pretiekol spat o hodnotu bajtu delitela. 
				movf	INDF1,w		; nacitanie registra delitela
				addwf	INDF0,f		; pripocitaj (vrat) zvysok hodnoty 
		;---------------------
					;navrat hodnoty dalsich vyssich bajtov delitela do delenca, pred bajtom, ktory sposobil...
					;...retazove pretecenie. Ak neexistuju vyssie bajty, tj. pretecenie sposobil najvyssi, tento...
					;...proces sa preskoci.
				movlw	.1  
				subwf	AKTUALNY_BAJT_DELITELA,w
				btfsc	STATUS,Z
				goto	preskoc_navrat
						;Vlozenie zvysnych (vyssich) bajtov spat do delitela 
					decf	AKTUALNY_BAJT_DELITELA,w
					movwf	POSUN_V_DELITELI
					opakuj_vkladanie
							;Subezny posun adries delenca a delitela
						movlw	.2
						addwf	FSR0L
						incf	FSR1L,f
							;Vkladanie hodnot delitela na prislusne adresy bajtov delenca
						movf	INDF1,w
						movwf	INDF0
					decfsz	POSUN_V_DELITELI,f
					goto	opakuj_vkladanie
						;Vratenie ukazatelov adries spat.
					decf	AKTUALNY_BAJT_DELITELA,w
					movwf	TMP
					subwf	FSR1L,f
					lslf	TMP,w
					subwf	FSR0L
				preskoc_navrat
		;-----------------------------
					;navrat adresy delenca o n pozicii (v pamati je to pozicia 2n-1)
				lslf	AKTUALNY_BAJT_DELITELA,w		;*2
				addwf	FSR0L,f
				decf	FSR0L,f							;-1
					;navrat adresy delitela o n pozicii. (Bajty delitela zacinaju od nuly, preto odpocitavam 1)
				;movlw	Adr_L_delitel + DLZKA_DELITELA
				movf	DLZKA_DELITELA,w
;				addlw	Adr_L_delitel
				addwf	ADRESA_L_DELITELA,w
				movwf	FSR1L				;posun pozicie v registroch delenca o 1 menej
				goto	vyskoc_z_delenia
			preskoc_opustenie_delenia
				;navrat adresy delitela o n pozicii. (Bajty delitela zacinaju od nuly, preto odpocitavam 1)
			;movlw	Adr_L_delitel + DLZKA_DELITELA	
			movf	DLZKA_DELITELA,w
;			addlw	Adr_L_delitel			
			addwf	ADRESA_L_DELITELA,w	
			movwf	FSR1L							;posun pozicie v registroch delenca o 1 menej
			decf	FSR0L,f
		decfsz	POCET_BAJTOV_DELITELA
		goto	posun_bajtov_delitela
	goto	delenie
	vyskoc_z_delenia
			;Posun adries vysledku, kvoli zarovnaniu jeho cisel doprava v pamati pri deliteloch dlhsich ako 1 bajt.
		;movlw	DLZKA_DELITELA - 1
		decf	DLZKA_DELITELA,w
		movwf	TMP
		lslf	TMP,w
		subwf	FSR0L,f
			;odpocitanie 1 od pocitadla podielu (vysledku), lebo pretecenie napocitalo 1 naviac
		decf	INDF0,f		
			;Navrat ukazatela v pamati spat na povodne miesto.
		lslf	TMP,w
		addwf	FSR0L,f
			;posun v registroch delenca o 1 poziciu nizsie (sme na pozicii pocitadla podielu (vysledku))
		movlw	.2
		subwf	FSR0L,f
	decfsz	POCET_MIEST
	goto	delenie
	;================================================================================================
	preskoc_cele_delenie
			;Zlozenie, poukladanie registrov podielu (vysledku) vedla seba. (Povodny obsah je premazany.)
		movlw	Dlzka_delenca-1
		movwf	POCET_MIEST
		clrf	TMP_TMP
;		movlw	Adr_H_sub2
		movf	ADRESA_H_DELENCA_A_VYSLEDKU,w
		movwf	FSR0H
;		movlw	Adr_L_sub2 + 2*Dlzka_delenca
		movlw	2*Dlzka_delenca
		addwf	ADRESA_L_DELENCA_A_VYSLEDKU,w
		movwf	FSR0L
	zlozenie
		movlw	.2
		addwf	TMP_TMP
		movf	TMP_TMP,w
		subwf	FSR0L
		movf	INDF0,w
		movwf	TMP
		movlw	.1
		subwf	TMP_TMP
		movf	TMP_TMP,w
		addwf	FSR0L
		movf	TMP,w
		movwf	INDF0
	decfsz	POCET_MIEST
	goto	zlozenie
		movlw	Dlzka_delenca
		movwf	POCET_MIEST
	;vymazanie obsahu druhej polovice pamate "delenec,podiel".
	premazanie_zvysku
		decf	FSR0L,f
		clrf	INDF0
	decfsz	POCET_MIEST
	goto	premazanie_zvysku
		;Skopirovanie vysledku na od zaciatku adresy
	movlw	Dlzka_delenca
	movwf	POCET_MIEST
	movf	ADRESA_H_DELENCA_A_VYSLEDKU,w
	movwf	FSR0H
	movf	ADRESA_L_DELENCA_A_VYSLEDKU,w
	movwf	FSR0L
	movf	ADRESA_H_DELENCA_A_VYSLEDKU,w
	movwf	FSR1H
	movf	ADRESA_L_DELENCA_A_VYSLEDKU,w
	addlw	Dlzka_delenca+1
	movwf	FSR1L
opakuj_kopirovanie_podielu
		movf	INDF1,w
		movwf	INDF0
		clrf	INDF1
		incf	FSR0L,f
		incf	FSR1L,f
	decfsz	POCET_MIEST,f
	goto	opakuj_kopirovanie_podielu
;	banksel	PORTA
return






;*****************************************************************************************************************
;*************************** NASOBENIE VIACBYTOVEHO CISLA VIACBYTOVYM NASOBITELOM **********************************
;*****************************************************************************************************************

;Podprogram nasobenia pripocitava viacbajtove nasobene cislo k sebe samemu. Kumulativny vysledok sa najskor....
;...uklada na zrkadlove adresy za adresami nasobeneho cisla (preto je potrebny dvojnasobok pamate). Po skonceni...
;...nasobenia sa vysledok skopiruje na adresy nasobeneho cisla. -Bajty nasobitela (tj. hodnota kolko krat...
;...sa ma cislo znasobit), maju svoju samostatne adresy, ine nez ma nasobene cislo.

Nasobenie
	banksel	POCET_MIEST
			clrf	POSUN_NASOBITELA
				;automaticke urcenie poctu bajtov nasobitela
			movlw	dlzka_cisla
			movwf	POCET_BYTE_NASOBITELA
;			movlw	Adr_H_nasobitel
			movf	ADRESA_H_NASOBITELA,w	
			movwf	FSR0H
		opakuj_test_nasobitela
;			movlw	Adr_L_nasobitel-1
			movlw	1
			subwf	ADRESA_L_NASOBITELA,w
			addwf	POCET_BYTE_NASOBITELA,w
			movwf	FSR0L
			decf	POCET_BYTE_NASOBITELA,f
			movf	INDF0,w
			btfsc	STATUS,Z
			goto	opakuj_test_nasobitela
			incf	POCET_BYTE_NASOBITELA,f
		opakuj_posun_nasobitela
					;Postupne nacitavanie viacbajtoveho nasobitela
;				movlw	Adr_H_nasobitel
				movf	ADRESA_H_NASOBITELA,w
				movwf	FSR0H
;				movlw	Adr_L_nasobitel
				movf	ADRESA_L_NASOBITELA,w
				addwf	POSUN_NASOBITELA,w
				movwf	FSR0L
				incf	POSUN_NASOBITELA,f
					;Nacitanie aktualneho bajtu nasobitela (kolko krat sa ma cislo znasobit).
				movf	INDF0,w
				movwf	POCET_KRAT
					;Test nuloveho bajtu nasobitela
				btfsc	STATUS,Z
				goto	preskoc_kalkulaciu
				;Cislo ktore sa ma nasobit, sa opakovane pripocitava k sebe samemu ten pocet krat, kolko je nasobitel.
			opakuj_pripocitanie
					;pocet registrov na kalkulaciu
				movlw	dlzka_cisla
				movwf	POCET_REGISTROV
					;adresa prveho registra v poli
				movf	ADRESA_H_NASOBENEHO_CISLA,w
				movwf	FSR0H
				movf	ADRESA_L_NASOBENEHO_CISLA,w
				movwf	FSR0L
				movf	ADRESA_H_NASOBENEHO_CISLA,w
				movwf	FSR1H
				movf	ADRESA_L_NASOBENEHO_CISLA,w
				addlw	dlzka_cisla
				movwf	FSR1L
				;Samotna kalkulacia - cize pripocitavanie viacbajtoveho cisla k sebe samemu
			opakuj_kalkulaciu_pripocitania
					;pripocitaj svoju vlastnu hodnotu (register INDF1 je kumulativny)
				movf	INDF0,w
				addwf	INDF1,f
					;vyhodnot, ci register pretiekol. Ak ano, nastav flag-bit do 1, v opacnom pripade vynuluj.
				btfsc	STATUS,C
				bsf		Pripocitanie_povolene
				btfss	STATUS,C
				bcf		Pripocitanie_povolene
					;Ak register pretiekol, idu sa pripocitavat nasledujuce o +1.
				btfss	Pripocitanie_povolene
				goto	preskoc_pripocitavanie
						;Skopiruj aktualnu polohu v registroch sciitanca.
					movf	POCET_REGISTROV,w
					movwf	ZVYSOK_REGISTROV
						;pripocitanie 1 do ostatnych registrov pokracuje dovtedy, dokedy ten predosly pretiekol.
					opakuj_pripocitavanie
						incf	FSR1L,f
						btfss	Pripocitanie_povolene
						goto	preskoc_vykonanie_pripocitania
							movlw	.1
							addwf	INDF1,f
								;akonahle sa skoncilo s preteceniami, pripocitavanie 1 do dalsich registrov sa zastavi.
							btfss	STATUS,C
							bcf		Pripocitanie_povolene
						preskoc_vykonanie_pripocitania
					decfsz	ZVYSOK_REGISTROV,f
					goto	opakuj_pripocitavanie
					;Po skonceni posuvu po zvysku registrov vrat ukazatel v pamati na povodne miesto.
				movf	POCET_REGISTROV,w
				subwf	FSR1L,f
				preskoc_pripocitavanie
					;Posun scitancov o register vyssie (vysledok je na adresach FSR1).
				incf	FSR0L,f					
				incf	FSR1L,f					
				decfsz	POCET_REGISTROV,f
				goto	opakuj_kalkulaciu_pripocitania
				;Celu proceduru pripocitavania vsetkych registrov opakuj tolko krat, kolko ma byt cislo znasobene
			decfsz	POCET_KRAT,f
			goto	opakuj_pripocitanie	
		preskoc_kalkulaciu		;V pripade nuloveho bajtu nasobitela sa skoci sem. (Preskoci sa kalkulacia.)
					;Posun nasobeneho cisla o 1 rad vyssie. (...na spodok sa pridavaju nuly...)
				movlw	dlzka_cisla
				movwf	POCET_REGISTROV
;				movlw	Adr_H_subsub1
				movf	ADRESA_H_NASOBENEHO_CISLA,w
				movwf	FSR0H
		opakuj_posun_radu
					;Posun ukazatela na poslednu cislicu nasobeneho cisla
;				movlw	Adr_L_subsub1 - 1
				movlw	1
				subwf	ADRESA_L_NASOBENEHO_CISLA,w
				addwf	POCET_REGISTROV,w
				movwf	FSR0L
					;skopirovanie cislice na adresu o 1 bajt vyssie
				decf	FSR0L,f
				movf	INDF0,w
				incf	FSR0L,f
				movwf	INDF0
					;prechod o 1 bajt nizsie
				decf	FSR0L,f
				decfsz	POCET_REGISTROV,f
				goto	opakuj_posun_radu
					;vlozenie nul na najspodnejsi bajt
				clrf	INDF0
			;posun na dalsi bajt nasobitela
		decf	POCET_BYTE_NASOBITELA,f
		btfss	STATUS,Z
		goto	opakuj_posun_nasobitela
			;Skopirovanie vysledku na adresy nasobeneho cisla
		movlw	dlzka_cisla
		movwf	POCET_REGISTROV
			;adresa prveho registra v poli
;		movlw	Adr_H_subsub1
		movf	ADRESA_H_NASOBENEHO_CISLA,w
		movwf	FSR0H
;		movlw	Adr_L_subsub1
		movf	ADRESA_L_NASOBENEHO_CISLA,w
		movwf	FSR0L
;		movlw	Adr_H_subsub1
		movf	ADRESA_H_NASOBENEHO_CISLA,w
		movwf	FSR1H
;		movlw	Adr_L_subsub1 + dlzka_cisla
		movf	ADRESA_L_NASOBENEHO_CISLA,w
		addlw	dlzka_cisla
		movwf	FSR1L
	opakuj_kopirovanie_sucinu
		movf	INDF1,w
		movwf	INDF0
		incf	FSR0L,f
		incf	FSR1L,f
		decfsz	POCET_REGISTROV,f
		goto	opakuj_kopirovanie_sucinu
;	banksel	PORTA
	return




;*****************************************************************************************************************
;*************************** SCITANIE DVOCH VIACBYTOVYCH SCITANCOV ***********************************************
;*****************************************************************************************************************

scitanie
	banksel	POCET_MIEST
			;pocet registrov na kalkulaciu
		movlw	Dlzka_scitanca
		movwf	POCET_REGISTROV
			;adresa prveho registra v poli
		movf	ADRESA_H_SCITANEC,w
		movwf	FSR0H
		movf	ADRESA_L_SCITANEC,w
		movwf	FSR0L
		movf	ADRESA_H_SCITANEC_A_VYSLEDOK,w
		movwf	FSR1H
		movf	ADRESA_L_SCITANEC_A_VYSLEDOK,w
		movwf	FSR1L
		;Samotna kalkulacia - cize pripocitavanie viacbajtoveho cisla k sebe samemu
	opakuj_kalkulaciu_suctu
			;pripocitaj svoju vlastnu hodnotu (register INDF1 je kumulativny)
		movf	INDF0,w
		addwf	INDF1,f
			;vyhodnot, ci register pretiekol. Ak ano, nastav flag-bit do 1, v opacnom pripade vynuluj.
		btfsc	STATUS,C
		bsf		Pripocitanie_povolene
		btfss	STATUS,C
		bcf		Pripocitanie_povolene
			;Ak register pretiekol, idu sa pripocitavat nasledujuce o +1.
		btfss	Pripocitanie_povolene
		goto	preskoc_sucet
				;Skopiruj aktualnu polohu v registroch sciitanca.
			movf	POCET_REGISTROV,w
			movwf	ZVYSOK_REGISTROV
				;pripocitanie 1 do ostatnych registrov pokracuje dovtedy, dokedy ten predosly pretiekol.
			opakuj_sucet
				incf	FSR1L,f
				btfss	Pripocitanie_povolene
				goto	preskoc_vykonanie_pripocitania
					movlw	.1
					addwf	INDF1,f
						;akonahle sa skoncilo s preteceniami, pripocitavanie 1 do dalsich registrov sa zastavi.
					btfss	STATUS,C
					bcf		Pripocitanie_povolene
				preskoc_vykonanie_suctu
			decfsz	ZVYSOK_REGISTROV,f
			goto	opakuj_sucet
			;Po skonceni posuvu po zvysku registrov vrat ukazatel v pamati na povodne miesto.
		movf	POCET_REGISTROV,w
		subwf	FSR1L,f
		preskoc_sucet
			;Posun scitancov o register vyssie (vysledok je na adresach FSR1).
		incf	FSR0L,f					
		incf	FSR1L,f					
		decfsz	POCET_REGISTROV,f
		goto	opakuj_kalkulaciu_suctu
;	banksel	PORTA
return



;*****************************************************************************************************************
;*************************** ODCITANIE VIACBYTOVEHO MENSENCA OD VIACBYTOVEHO MENSITELA ***************************
;*****************************************************************************************************************


odcitanie
	banksel	POCET_MIEST
			movf	ADRESA_H_MENSITEL,w
			movwf	FSR0H
			movf	ADRESA_L_MENSITEL,w
			movwf	FSR0L
			movf	ADRESA_H_MENSENEC,w
			movwf	FSR1H
			movf	ADRESA_L_MENSENEC,w
			movwf	FSR1L
			movlw	Dlzka_rozdielu
			movwf	DLZKA_ROZDIELU
			clrf	BAJTY_NA_DEKREMENTACIU
			posun_bajtu_odcitania
				movf	DLZKA_ROZDIELU,w
				movwf	BAJTY_NA_DEKREMENTACIU
					;Odcitanie dvoch cisel
				movf	INDF0,w		
				subwf	INDF1,f	
				btfss	STATUS,C
				bsf		Odpocet_povoleny
				btfsc	STATUS,C
				bcf		Odpocet_povoleny
				btfss	Odpocet_povoleny
				goto	preskoc_dekrementaciu
					opakuj_dekrementaciu
							;Posun ukazatela na dalsi bajt
						incf	FSR1L,f	
							;Retazova dekrementacia. Kazdy register sa dekrementuje, ak ten pred nim pretiekol.
						btfss	Odpocet_povoleny
						goto	preskoc_vykonanie_dekrementacie
								;odpocitanie 1 od registra vyssie
							movlw	.1
							subwf	INDF1,f	
							btfss	STATUS,C
							bsf		Odpocet_povoleny
							btfsc	STATUS,C
							bcf		Odpocet_povoleny				
						preskoc_vykonanie_dekrementacie
					decfsz BAJTY_NA_DEKREMENTACIU
					goto opakuj_dekrementaciu
						;Vratenie ukazatela spat na povodne cislo
					movf	DLZKA_ROZDIELU,w
					subwf	FSR1L,f	
				preskoc_dekrementaciu
					;Posun ukatelov v pamati
				incf	FSR0L,f
				incf	FSR1L,f
			decfsz	DLZKA_ROZDIELU
			goto	posun_bajtu_odcitania
				;Ak posledny bajt je FF, jednalo sa zrejme o nekonecne pretecenie, cize zaporny vysledok.
				;Preto vynuluj vysledok
			decf	FSR1L,f
			movlw	0xFF
			subwf	INDF1,w
			btfss	STATUS,Z
			goto	preskoc_vynulovanie_vysledku
				movf	ADRESA_H_MENSENEC,w
				movwf	FSR1H
				movf	ADRESA_L_MENSENEC,w
				movwf	FSR1L
				movlw	Dlzka_rozdielu
				movwf	DLZKA_ROZDIELU
				opakuj_vynulovanie_vysledku
					clrf	INDF1
					incf	FSR1L,f
				decfsz	DLZKA_ROZDIELU,f
				goto	opakuj_vynulovanie_vysledku
			preskoc_vynulovanie_vysledku
;	banksel	PORTA
return


;oooo
;*****************************************************************************************************************
;********** VYPOCET FREKVENCIE ZO ZADANEHO VIACBYTOVEHO BCD CISLA PRE REGISTRE DO MODULU SI5351A. ***************************
;*****************************************************************************************************************

		;**********************************************************************************************
		;************** POSTUP VYPOCTU FREKVENCIE PRE REGISTRE MODULU SI5351A *************************
		;**********************************************************************************************
			;Set VCOs of PLLA and PLLB to 900 MHz (konstantne nastavenie PLLA a PLLB)
			;a = 36;           // Division factor 900/25 MHz 
			;b = 0;            // Numerator, sets b/c=0 
			;c = 1048575;      //Max. resolution, but irrelevant in this case (b=0) 
			;f_xtal = 25000000
			;//Formula for splitting up the numbers to register data, see AN619 
			;pp1 = 128 * a + (unsigned long) (128 * b / c) - 512; 
			;pp2 = 128 * b - c * (unsigned long) (128 * b / c); 
			;pp3  = c; 
			;
			;Nastavenie frekvencie pre vf vystupy MS_0 a/alebo MS_1 a/alebo MS_2:
			;fdiv = (double) (f_xtal * 36) / freq; //division factor fvco/freq (will be integer part of a+b/c) 
			;a = (unsigned long) fdiv; 
			;rm = fdiv - a;  //remainder. (equiv. b/c) 
			;b = rm * c; 
			;pp1  = 128 * a + (unsigned long) (128 * b / c) - 512; 
			;pp2 = 128 * b - c * (unsigned long) (128 * b / c); 
			;pp3 = c; 
			;Pre potreby PIC assembleru kde sa da pracovat len s celymi cislami, som vypocet upravil do inej...
			;...podoby, lebo sa v nom pracuje so zvyskami po deleni:
			;sub1 = 900000000 / freq
			;sub2 = 9000000000000000 / freq
			;subsub1 = 1048575 * sub1
			;subsub2 = (1048575 * sub2) / 10000000
			;subsubsub = 128 * (subsub2 - subsub1)	
			;subsubsubsub = subsubsub / 1048575
			;pp1  = 128 * sub1 + subsubsubsub - 512
			;pp2 = subsubsub - 1048575 * subsubsubsub
			;.....pp1 a pp2 su vysledne hodnoty, ktore su rozhodene do viacerych registrov modulu SI5351A
			;*************** TOTO JE POUZITE V TOMTO PODPROGRAME: ********************************************
			;HEX prepocet vypoctu pre potreby programu, lebo viacregistrova hodnota sa vyskladava z hex
			;sub1 = 35A4E900 / freq
			;sub2 = 1FF973CAFA8000 / freq
			;subsub1 = FFFFF * sub1;
			;subsub2 = (FFFFF * sub2) / 989680;	
			;subsubsub = 80 * (subsub2 - subsub1);	
			;subsubsubsub = subsubsub / FFFFF;	
			;pp1  = 80 * sub1 + subsubsubsub - 200; 
			;pp2 = subsubsub - FFFFF * subsubsubsub; 
			;
			;Osem registrov SYNTH_MS_0 a/alebo SYNTH_MS_1 a/alebo SYNTH_MS_2 do modulu SI5351A su obsadene takto:
			;reg_0 = 0xFF;
			;reg_1 = 0xFF;
			;reg_2 = ((pp1 & 0x00030000) >> 16);
			;reg_3 = ((pp1 & 0x0000FF00) >> 8);
			;reg_4 = (pp1 & 0x000000FF);
			;reg_5 = 0xF0 | ((pp2 & 0x000F0000) >> 16);
			;reg_6 = ((pp2 & 0x0000FF00) >> 8);
			;reg_7 = (pp2 & 0x000000FF);
			;....v tomto programe (PIC assembleri) je to vsak jednoduchsie obsadzovat.
		;**********************************************************************************************
		;**********************************************************************************************
	;Na vstup podprogramu sa zadava 8 miestne cislo frekvencie v BCD kode na prislusne adresy. 
Vypocet_frekvencie
;	banksel	POCET_MIEST
			;Nepusti pri ladeni do registrov BCD viac nez cislo 9. Ak presiahne, pripocitaj 1 do vyssieho registra.
		call	Vykalkulovanie_BCD_cisla
			;Prevedie zobrazenu frekvenciu v BCD na displeji, na skutocne 32 bitove cislo, pouzitelne vo vypoctoch.
		call	Prevod_BCD_na_HEX

			;Vysledok sa ocitne v 4-och bajtoch od adresy: "Adr_L_BCD_na_HEX". Najnizsi bajt = najnizsi rad.
		;******************************************************************************************************************
		;************************************** sub2 = 1FF973CAFA8000 / freq *************************************************
		;******************************************************************************************************************
			;Zadanie adries pre delenie		
		movlw	Adr_H_BCD_na_HEX				;delitelom je vysledok zadanej frekvencie v HEX
		movwf	ADRESA_H_DELITELA
		movlw	Adr_L_BCD_na_HEX				;delitelom je vysledok zadanej frekvencie v HEX
		movwf	ADRESA_L_DELITELA
			;Vlozenie delenca do registrov
		movlw	Adr_H_sub2
		movwf	ADRESA_H_DELENCA_A_VYSLEDKU
		movwf	FSR0H
		movlw	Adr_L_sub2
		movwf	ADRESA_L_DELENCA_A_VYSLEDKU
		movwf	FSR0L
		movlw	0x00				; delenec 0	
		movlw	0x00				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x80				; delenec 1	
		movlw	0x84				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xFA				; delenec 2	
		movlw	0x65				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xCA				; delenec 3	
		movlw	0xBF				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x73				; delenec 4
		movlw	0x88				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xF9				; delenec 5	
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x1F				; delenec 6	
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x00				; delenec 7
		movwf	INDF0
			;Zavolanie podprogramu na vypocet delenia
		call	Vydelenie
			;Vysledok je na adresach delenca SUB2
		;******************************************************************************************************************
		;************************************** sub1 = 35A4E900 / freq *************************************************
		;******************************************************************************************************************
			;Zadanie adries pre delenie
		movlw	Adr_H_sub1
		movwf	ADRESA_H_DELENCA_A_VYSLEDKU
		movwf	FSR0H
		movlw	Adr_L_sub1
		movwf	ADRESA_L_DELENCA_A_VYSLEDKU
		movwf	FSR0L		
		; Adresa delenca zostava rovnaka, ako v predoslom sub2.
		movlw	0x00				; delenec 0	
		movlw	0x28				; delenec 0	
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xE9				; delenec 1	
		movlw	0x0C				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xA4				; delenec 2	
		movlw	0xA5				; delenec 7
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x35				; delenec 3	
		movwf	INDF0
			incf	FSR0L,f
			;Zavolanie podprogramu na vypocet delenia
		call	Vydelenie
			;Vysledok je na adresach delenca SUB2
		;******************************************************************************************************************
		;************************************** subsub1 = FFFFF * sub1; *************************************************
		;******************************************************************************************************************
			;Zadanie adries nasobitela (tj. kolko krat sa ma cislo znasobit)
		movlw	Adr_H_sub1		;Nasobitelom je vysledok z predosleho delenia (podla postupu)
		movwf	ADRESA_H_NASOBITELA
		movlw	Adr_L_sub1		;Nasobitelom je vysledok z predosleho delenia (podla postupu)
		movwf	ADRESA_L_NASOBITELA
			;Zadanie adries nasobeneho cisla (tj. cisla, ktore sa bude nasobit)
		movlw	Adr_H_subsub1
		movwf	ADRESA_H_NASOBENEHO_CISLA
		movwf	FSR0H
		movlw	Adr_L_subsub1
		movwf	ADRESA_L_NASOBENEHO_CISLA
		movwf	FSR0L
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x0F
		movwf	INDF0
			;Vykonanie nasobenia
		call	Nasobenie
			;Vysledok je na adresach nasobeneho cisla
		;******************************************************************************************************************
		;************************************** subsub2 = (FFFFF * sub2) / 989680 *************************************************
		;******************************************************************************************************************
			;Zadanie adries nasobitela (tj. kolko krat sa ma cislo znasobit)
		movlw	Adr_H_sub2		;Nasobitelom je vysledok z predosleho delenia (podla postupu)
		movwf	ADRESA_H_NASOBITELA
		movlw	Adr_L_sub2		;Nasobitelom je vysledok z predosleho delenia (podla postupu)
		movwf	ADRESA_L_NASOBITELA
			;Zadanie adries nasobeneho cisla (tj. cisla, ktore sa bude nasobit)
		movlw	Adr_H_subsub2
		movwf	ADRESA_H_NASOBENEHO_CISLA
		movwf	FSR0H
		movlw	Adr_L_subsub2
		movwf	ADRESA_L_NASOBENEHO_CISLA
		movwf	FSR0L
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x0F
		movwf	INDF0
			;Vykonanie nasobenia
		call	Nasobenie
			;Vysledok je na adresach nasobeneho cisla
			;Delitelom je v tomto pripade pevne cislo	
		movlw	Adr_H_delitel				;delitelom je vysledok zadanej frekvencie v HEX
		movwf	ADRESA_H_DELITELA
		movwf	FSR0H
		movlw	Adr_L_delitel				;delitelom je vysledok zadanej frekvencie v HEX
		movwf	ADRESA_L_DELITELA
		movwf	FSR0L
		movlw	0x80
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x96
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x98
		movwf	INDF0
			;Adresa pre delenca je vysledok z predosleho nasobenia
		movlw	Adr_H_subsub2
		movwf	ADRESA_H_DELENCA_A_VYSLEDKU	
		movlw	Adr_L_subsub2
		movwf	ADRESA_L_DELENCA_A_VYSLEDKU
			;Zavolanie podprogramu na vypocet delenia
		call	Vydelenie
			;Vysledok je na adresach delenca SUBSUB2
		;******************************************************************************************************************
		;************************************** subsubsub = 80 * (subsub2 - subsub1) *************************************************
		;******************************************************************************************************************
		movlw	Adr_H_subsub1
		movwf	ADRESA_H_MENSITEL
		movlw	Adr_L_subsub1
		movwf	ADRESA_L_MENSITEL
		movlw	Adr_H_subsub2
		movwf	ADRESA_H_MENSENEC
		movlw	Adr_L_subsub2
		movwf	ADRESA_L_MENSENEC
			;Zavolanie podprogramu na vypocet delenia
		call	odcitanie
			;Vysledok je na adresach mensenca
			;Zadanie adries nasobitela (tj. kolko krat sa ma cislo znasobit)
		movlw	Adr_H_subsub2		;Nasobitelom je vysledok z predosleho odcitania (podla postupu)
		movwf	ADRESA_H_NASOBITELA
		movlw	Adr_L_subsub2		;Nasobitelom je vysledok z predosleho odcitania (podla postupu)
		movwf	ADRESA_L_NASOBITELA
			;Zadanie adries nasobeneho cisla (tj. cisla, ktore sa bude nasobit)
		movlw	Adr_H_subsubsub
		movwf	ADRESA_H_NASOBENEHO_CISLA
		movwf	FSR0H
		movlw	Adr_L_subsubsub
		movwf	ADRESA_L_NASOBENEHO_CISLA
		movwf	FSR0L
		movlw	0x80
		movwf	INDF0
			;Vykonanie nasobenia
		call	Nasobenie
			;Vysledok je na adresach nasobeneho cisla
		;******************************************************************************************************************
		;************************************** subsubsubsub = subsubsub / FFFFF *************************************************
		;******************************************************************************************************************
			;Skopirovanie subsubsub do subsubsubsub, lebo subsubsub sa bude este potrebovat.
		movlw	Adr_H_subsubsub
		movwf	FSR0H
		movlw	Adr_L_subsubsub
		movwf	FSR0L
		movlw	Adr_H_subsubsubsub
		movwf	FSR1H
		movlw	Adr_L_subsubsubsub
		movwf	FSR1L
		movlw	dlzka_cisla
		movwf	DLZKA_ROZDIELU
		opakuj_kopirovanie
			movf	INDF0,w
			movwf	INDF1
			incf	FSR0,f
			incf	FSR1,f
		decfsz	DLZKA_ROZDIELU
		goto	opakuj_kopirovanie
			;Delitelom je v tomto pripade pevne cislo	
		movlw	Adr_H_delitel				;delitelom je vysledok zadanej frekvencie v HEX
		movwf	ADRESA_H_DELITELA
		movwf	FSR0H
		movlw	Adr_L_delitel				;delitelom je vysledok zadanej frekvencie v HEX
		movwf	ADRESA_L_DELITELA
		movwf	FSR0L
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x0F
		movwf	INDF0
			;Adresa pre delenca je skopirovany vysledok z predosleho vypoctu
		movlw	Adr_H_subsubsubsub
		movwf	ADRESA_H_DELENCA_A_VYSLEDKU		
		movlw	Adr_L_subsubsubsub
		movwf	ADRESA_L_DELENCA_A_VYSLEDKU
			;Zavolanie podprogramu na vypocet delenia
		call	Vydelenie
			;Vysledok je na adresach delenca SUBSUB2
		;******************************************************************************************************************
		;************************************** pp1  = 80 * sub1 + subsubsubsub - 200 *************************************************
		;******************************************************************************************************************
			;Zadanie adries nasobitela (tj. kolko krat sa ma cislo znasobit)
		movlw	Adr_H_sub1			;Nasobitelom je vysledok sub1 (podla postupu)
		movwf	ADRESA_H_NASOBITELA
		movlw	Adr_L_sub1			;Nasobitelom je vysledok sub1 (podla postupu)
		movwf	ADRESA_L_NASOBITELA
			;Zadanie adries nasobeneho cisla (tj. cisla, ktore sa bude nasobit)
		movlw	Adr_H_pp1
		movwf	ADRESA_H_NASOBENEHO_CISLA
		movwf	FSR0H
		movlw	Adr_L_pp1
		movwf	ADRESA_L_NASOBENEHO_CISLA
		movwf	FSR0L
		movlw	0x80
		movwf	INDF0
			;Vykonanie nasobenia
		call	Nasobenie
			;Vysledok je na adresach nasobeneho cisla
		movlw	Adr_H_subsubsubsub
		movwf	ADRESA_H_SCITANEC
		movlw	Adr_L_subsubsubsub
		movwf	ADRESA_L_SCITANEC
		movlw	Adr_H_pp1
		movwf	ADRESA_H_SCITANEC_A_VYSLEDOK
		movlw	Adr_L_pp1
		movwf	ADRESA_L_SCITANEC_A_VYSLEDOK
		call	scitanie
		movlw	Adr_H_mensitel
		movwf	ADRESA_H_MENSITEL
		movwf	FSR0H
		movlw	Adr_L_mensitel
		movwf	ADRESA_L_MENSITEL
		movwf	FSR0L
		movlw	0x00
		movwf	INDF0
		incf	FSR0L,f
		movlw	0x02
		movwf	INDF0
		movlw	Adr_H_pp1
		movwf	ADRESA_H_MENSENEC
		movlw	Adr_L_pp1
		movwf	ADRESA_L_MENSENEC
			;Zavolanie podprogramu na vypocet delenia
		call	odcitanie
			;Vysledok je na adresach mensenca
		;******************************************************************************************************************
		;************************************** pp2 = subsubsub - FFFFF * subsubsubsub *************************************************
		;******************************************************************************************************************
			;Zadanie adries nasobitela (tj. kolko krat sa ma cislo znasobit)
		movlw	Adr_H_subsubsubsub			;Nasobitelom je vysledok subsubsubsub (podla postupu)
		movwf	ADRESA_H_NASOBITELA
		movlw	Adr_L_subsubsubsub			;Nasobitelom je vysledok subsubsubsub (podla postupu)
		movwf	ADRESA_L_NASOBITELA
			;Zadanie adries nasobeneho cisla (tj. cisla, ktore sa bude nasobit)
		movlw	Adr_H_pp2
		movwf	ADRESA_H_NASOBENEHO_CISLA
		movwf	FSR0H
		movlw	Adr_L_pp2
		movwf	ADRESA_L_NASOBENEHO_CISLA
		movwf	FSR0L
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0xFF
		movwf	INDF0
			incf	FSR0L,f
		movlw	0x0F
		movwf	INDF0
			;Vykonanie nasobenia
		call	Nasobenie
			;Vysledok je na adresach nasobeneho cisla
		movlw	Adr_H_pp2
		movwf	ADRESA_H_MENSITEL
		movlw	Adr_L_pp2
		movwf	ADRESA_L_MENSITEL
		movlw	Adr_H_subsubsub
		movwf	ADRESA_H_MENSENEC
		movlw	Adr_L_subsubsub
		movwf	ADRESA_L_MENSENEC
			;Zavolanie podprogramu na vypocet delenia
		call	odcitanie
			;Vysledok je na adresach mensenca
			;Skopirovanie subsubsub do pp2, lebo vysledok sa ocitol v subsubsub. (robim to kvoli poriadku)
		movlw	Adr_H_subsubsub
		movwf	FSR0H
		movlw	Adr_L_subsubsub
		movwf	FSR0L
		movlw	Adr_H_pp2
		movwf	FSR1H
		movlw	Adr_L_pp2
		movwf	FSR1L
		movlw	dlzka_cisla
		movwf	DLZKA_ROZDIELU
		opakuj_kopirovanie_do_pp2
			movf	INDF0,w
			movwf	INDF1
			incf	FSR0,f
			incf	FSR1,f
		decfsz	DLZKA_ROZDIELU
		goto	opakuj_kopirovanie_do_pp2
	banksel	PORTA
return




;******** Postup vlozenia hodnoty len urcitych bitov do registra CIEL bez toho, aby sa ovplyvnili ostatne ********
	;Simulacia nejakej hodnoty, ktora je v cielovom registri. (Chceme ovplyvnovat len spodne 4 bity.)
;movlw	0xA3
;movwf	REG_7		
	;Nacitanie povodnej hodnoty cieloveho registra. Len tej casti, ktora sa nesmie menit. Ostatne su vynulovane.
;movf	REG_7,w
;andlw	0xF0		;Filter, ktory pusta z W registra len stav hornych 4 bitov, cize len cislo 0xA0
;movwf	TMP
	;Pridanie dalsej hodnoty do cieloveho registra. Len tej casti, ktora sa ma menit. 
;movlw	0x25
;andlw	0x0F		;Filter, ktory pusta z W registra len stav dolnych 4 bitov, cize len 0x05
;iorwf	TMP,f		;Zlucenie oboch hodnot 0xA0 a 0x05, cize vytvorenie cisla 0xA5
	;vlozenie oboch zlucenych hodnot naspat do cieloveho registra
;movf	TMP,w
;movwf	REG_7















;oooo
Prvotne_nastavenie_SI5351A
	banksel	POCET_MIEST

			;Uvedenie modulu Si5351A do cinnosti
		movlw	XTAL_LOAD_CAP			;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xD2					;Hodnota
		call	Write_Si5351
		movlw	CLK_ENABLE_CONTROL		;Adresa		
		movwf	ADRESA_REG_SI5351A
;		movlw	0x00					;Hodnota
		movlw	b'11111010'					;Hodnota - nechavam zapnuty len vystup CLK_0
		call	Write_Si5351
		movlw	CLK0_CONTROL				;Adresa		
		movwf	ADRESA_REG_SI5351A
;		movlw	0x2F					;Hodnota
			;ooooo Nastavenie vystupneho prudu - bity 0-1: 00:2mA, 01:4mA, 10:6mA, 11:8mA
		movlw	b'00101111'					;Hodnota
		call	Write_Si5351
		movlw	CLK1_CONTROL				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x2F					;Hodnota
		call	Write_Si5351
		movlw	CLK2_CONTROL			;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x2F					;Hodnota
		call	Write_Si5351
		movlw	PLL_RESET			;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xA0					;Hodnota
		call	Write_Si5351
			;Nastavenie PLL A
		movlw	SYNTH_PLL_A	+ 0				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 1				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 2				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 3				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x10					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 4				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 5				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xF0					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 6				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_A	+ 7				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
			;Nastavenie PLL B
		movlw	SYNTH_PLL_B	+ 0				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 1				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 2				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 3				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x10					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 4				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 5				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0xF0					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 6				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351
		movlw	SYNTH_PLL_B	+ 7				;Adresa		
		movwf	ADRESA_REG_SI5351A
		movlw	0x00					;Hodnota
		call	Write_Si5351

		call	Frekvencia_na_vystupe_0
		call	Frekvencia_na_vystupe_2



	banksel	PORTA
return




Frekvencia_na_vystupe_0
	banksel	POCET_MIEST
			;Nastavenie frekvencie na vf vystupe MS 0
		movlw	Adr_H_pp1
		movwf	FSR0H
		movlw	Adr_L_pp1 + 2			;Nastavenie ukazatela v pamati PIC, kde je ulozena hodnota vysledku pp1
		movwf	FSR0L
		movlw	SYNTH_MS_0	+ 0			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota na adresu
		call	Write_Si5351
		movlw	SYNTH_MS_0	+ 1			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota na adresu
		call	Write_Si5351
		movlw	SYNTH_MS_0	+ 2			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota z vysledku vypoctov pp1
		andlw	0x03					;Filter, ktory pusta z W registra len stav spodnych prvych 2 bitov.
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp1 o 1 bajt nizsie
		movlw	SYNTH_MS_0	+ 3			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp1
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp1 o 1 bajt nizsie
		movlw	SYNTH_MS_0	+ 4			;Adresa	v module Si5351		
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp1
		call	Write_Si5351
		movlw	Adr_H_pp2
		movwf	FSR0H
		movlw	Adr_L_pp2 + 2			;Nastavenie ukazatela v pamati PIC, kde je ulozena hodnota vysledku pp2
		movwf	FSR0L
		movlw	SYNTH_MS_0	+ 5			;Adresa	v module Si5351		
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp2
		andlw	0x0F					;Filter, ktory pusta z W registra len stav spodnych 4 bitov.
		iorlw	0xF0					;Stav hornych 4 bitov musia byt jednotky
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp2 o 1 bajt nizsie
		movlw	SYNTH_MS_0	+ 6			;Adresa	v module Si5351		
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp2
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp2 o 1 bajt nizsie
		movlw	SYNTH_MS_0	+ 7			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp2
		call	Write_Si5351

	;	movlw	PLL_RESET					;Adresa
	;	movwf	ADRESA_REG_SI5351A
	;	movlw	0XA0 ;0xAC					;Hodnota - soft reset
	;	movlw	0xAC					;Hodnota - soft reset
	;	call	Write_Si5351
	banksel	PORTA
return



Frekvencia_na_vystupe_2
	banksel	POCET_MIEST
			;Nastavenie frekvencie na vf vystupe MS 0
		movlw	Adr_H_pp1
		movwf	FSR0H
		movlw	Adr_L_pp1 + 2			;Nastavenie ukazatela v pamati PIC, kde je ulozena hodnota vysledku pp1
		movwf	FSR0L
		movlw	SYNTH_MS_2	+ 0			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota na adresu
		call	Write_Si5351
		movlw	SYNTH_MS_2	+ 1			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movlw	0xFF					;Hodnota na adresu
		call	Write_Si5351
		movlw	SYNTH_MS_2	+ 2			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota z vysledku vypoctov pp1
		andlw	0x03					;Filter, ktory pusta z W registra len stav spodnych prvych 2 bitov.
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp1 o 1 bajt nizsie
		movlw	SYNTH_MS_2	+ 3			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp1
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp1 o 1 bajt nizsie
		movlw	SYNTH_MS_2	+ 4			;Adresa	v module Si5351		
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp1
		call	Write_Si5351
		movlw	Adr_H_pp2
		movwf	FSR0H
		movlw	Adr_L_pp2 + 2			;Nastavenie ukazatela v pamati PIC, kde je ulozena hodnota vysledku pp2
		movwf	FSR0L
		movlw	SYNTH_MS_2	+ 5			;Adresa	v module Si5351		
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp2
		andlw	0x0F					;Filter, ktory pusta z W registra len stav spodnych 4 bitov.
		iorlw	0xF0					;Stav hornych 4 bitov musia byt jednotky
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp2 o 1 bajt nizsie
		movlw	SYNTH_MS_2	+ 6			;Adresa	v module Si5351		
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp2
		call	Write_Si5351
			decf	FSR0L,f				;Posun adresy v pamati PIC kde je hodnota pp2 o 1 bajt nizsie
		movlw	SYNTH_MS_2	+ 7			;Adresa	v module Si5351	
		movwf	ADRESA_REG_SI5351A
		movf	INDF0,w					;Hodnota na adresu z vysledku vypoctov pp2
		call	Write_Si5351

	;	movlw	PLL_RESET					;Adresa
	;	movwf	ADRESA_REG_SI5351A
	;	movlw	0XA0 ;0xAC					;Hodnota - soft reset
	;	movlw	0xAC					;Hodnota - soft reset
	;	call	Write_Si5351
	banksel	PORTA
return






Write_Si5351
	pagesel	nastavenie_PIC

		banksel	POCET_MIEST
		movwf	TMP_Si5351
		banksel	PORTA
			;Write sekvencia
		call	I2C_START
			;Adresa zariadenia (posledny bit = smer prenosu)
		movlw	SI5351_ADDRESS
		call	I2C_TXW
			;Adresa registra
		banksel	POCET_MIEST
		movf	ADRESA_REG_SI5351A,w
		banksel	PORTA
		call	I2C_TXW
			;Vlozenie bajtu na adresu.
		banksel	POCET_MIEST
		movf	TMP_Si5351,w
		banksel	PORTA
		call	I2C_TXW
		call	I2C_STOP
		banksel	POCET_MIEST
	pagesel	Vypocet_frekvencie

	return



CLK0_zap
	banksel	POCET_MIEST
		movlw	CLK_ENABLE_CONTROL
		movwf	ADRESA_REG_SI5351A
		movlw	b'11111110'
		call	Write_Si5351	
	banksel	PORTA
	return


CLK0_vyp
	banksel	POCET_MIEST
		movlw	CLK_ENABLE_CONTROL
		movwf	ADRESA_REG_SI5351A
		movlw	b'11111111'
		call	Write_Si5351	
	banksel	PORTA
	return




	;CITANIE REGISTROV Z MODULU SI5351A
Read_Si5351

	pagesel	nastavenie_PIC
			;Etapa 1 Read sekvencie
		call	I2C_START
			;Adresa zariadenia (posledny bit = smer prenosu)
		movlw	SI5351_ADDRESS
		call	I2C_TXW
			;Adresa registra
		banksel	POCET_MIEST
		movf	ADRESA_REG_SI5351A,w
		banksel	PORTA
		call	I2C_TXW
		call	I2C_STOP

			;Etapa 2 Read sekvencie
		call	I2C_START
			;Adresa zariadenia (posledny bit = smer prenosu)
		movlw	b'11000001'
		call	I2C_TXW
			;Precitanie bajtu na adrese.
		call	I2C_RXW_POSLEDNE
		movwf	TMP_TMP
		call	I2C_STOP
	pagesel	Vypocet_frekvencie

return









;===============================================================================================
;=================================== Definicia znakov MORSE ====================================
;===============================================================================================


_A
		call	bodka
		call	ciarka
		call	medzera
	return
_B
		call	ciarka
		call	bodka
		call	bodka
		call	bodka
		call	medzera
	return
_C
		call	ciarka
		call	bodka
		call	ciarka
		call	bodka
		call	medzera
	return
_D
		call	ciarka
		call	bodka
		call	bodka
		call	medzera
	return
_E
		call	bodka
		call	medzera
	return
_F
		call	bodka
		call	bodka
		call	ciarka
		call	bodka
		call	medzera
	return
_G
		call	ciarka
		call	ciarka
		call	bodka
		call	medzera
	return
_H
		call	bodka
		call	bodka
		call	bodka
		call	bodka
		call	medzera
	return
_I
		call	bodka
		call	bodka
		call	medzera
	return
_J
		call	bodka
		call	ciarka
		call	ciarka
		call	ciarka
		call	medzera
	return
_K
		call	ciarka
		call	bodka
		call	ciarka
		call	medzera
	return
_L
		call	bodka
		call	ciarka
		call	bodka
		call	bodka
		call	medzera
	return
_M
		call	ciarka
		call	ciarka
		call	medzera
	return
_N
		call	ciarka
		call	bodka
		call	medzera
	return
_O
		call	ciarka
		call	ciarka
		call	ciarka
		call	medzera
	return
_P
		call	bodka
		call	ciarka
		call	ciarka
		call	bodka
		call	medzera
	return
_Q
		call	ciarka
		call	ciarka
		call	bodka
		call	ciarka
		call	medzera
	return
_R
		call	bodka
		call	ciarka
		call	bodka
		call	medzera
	return
_S
		call	bodka
		call	bodka
		call	bodka
		call	medzera
	return
_T
		call	ciarka
		call	medzera
	return
_U
		call	bodka
		call	bodka
		call	ciarka
		call	medzera
	return
_V
		call	bodka
		call	bodka
		call	bodka
		call	ciarka
		call	medzera
	return
_X
		call	ciarka
		call	bodka
		call	bodka
		call	ciarka
		call	medzera
	return
_Y
		call	ciarka
		call	bodka
		call	ciarka
		call	ciarka
		call	medzera
	return
_Z
		call	ciarka
		call	ciarka
		call	bodka
		call	bodka
		call	medzera
	return
_1
		call	bodka
		call	ciarka
		call	ciarka
		call	ciarka
		call	ciarka
		call	medzera
	return
_2
		call	bodka
		call	bodka
		call	ciarka
		call	ciarka
		call	ciarka
		call	medzera
	return
_3
		call	bodka
		call	bodka
		call	bodka
		call	ciarka
		call	ciarka
		call	medzera
	return
_4
		call	bodka
		call	bodka
		call	bodka
		call	bodka
		call	ciarka
		call	medzera
	return
_5
		call	bodka
		call	bodka
		call	bodka
		call	bodka
		call	bodka
		call	medzera
	return
_6
		call	ciarka
		call	bodka
		call	bodka
		call	bodka
		call	bodka
		call	medzera
	return
_7
		call	ciarka
		call	ciarka
		call	bodka
		call	bodka
		call	bodka
		call	medzera
	return
_8
		call	ciarka
		call	ciarka
		call	ciarka
		call	bodka
		call	bodka
		call	medzera
	return
_9
		call	ciarka
		call	ciarka
		call	ciarka
		call	ciarka
		call	bodka
		call	medzera
	return
_0
		call	ciarka
		call	ciarka
		call	ciarka
		call	ciarka
		call	ciarka
		call	medzera
	return

_PLUS
		call	bodka
		call	ciarka
		call	bodka
		call	ciarka
		call	bodka
		call	medzera
	return

_MINUS
		call	ciarka
		call	bodka
		call	bodka
		call	bodka
		call	bodka
		call	ciarka
		call	medzera
	return

_CIARKA
		call	ciarka
		call	ciarka
		call	bodka
		call	bodka
		call	ciarka
		call	ciarka
		call	medzera
	return




_BODKA
		call	bodka
		call	ciarka
		call	bodka
		call	ciarka
		call	bodka
		call	ciarka

		call	medzera
	return


_OTAZNIK
		call	bodka
		call	bodka
		call	ciarka
		call	ciarka
		call	bodka
		call	bodka

		call	medzera
	return


_VYKRICNIK
		call	bodka
		call	bodka
		call	ciarka
		call	ciarka
		call	bodka

		call	medzera
	return



_DVOJBODKA
		call	ciarka
		call	ciarka
		call	ciarka
		call	bodka
		call	bodka
		call	bodka

		call	medzera
	return








bodka
		call	CLK0_zap
	;	bsf		LED

		pagesel	nastavenie_PIC
		call	LCD_LED_ZAP
		pagesel	Vykalkulovanie_BCD_cisla

		call	pauza_morze
		call	CLK0_vyp
	;	bcf		LED

		pagesel	nastavenie_PIC
		call	LCD_LED_VYP
		pagesel	Vykalkulovanie_BCD_cisla

		call	pauza_morze
	return





ciarka
		call	CLK0_zap
;		bsf		LED

		pagesel	nastavenie_PIC
		call	LCD_LED_ZAP
		pagesel	Vykalkulovanie_BCD_cisla

		call	pauza_morze
		call	pauza_morze
		call	pauza_morze
		call	CLK0_vyp
	;	bcf		LED

		pagesel	nastavenie_PIC
		call	LCD_LED_VYP
		pagesel	Vykalkulovanie_BCD_cisla

		call	pauza_morze
	return



pauza_morze
		movlw	rychlost_morze
		movwf	N100
m10		movlw	.100
		movwf	N10
		clrwdt
m1		movlw	.100
		movwf	N1
		decfsz	N1
		goto	$-1
		decfsz	N10
		goto	m1
		decfsz	N100
		goto	m10
	return



medzera
		call	pauza_morze
		call	pauza_morze
	return



medzera_slova
		call	medzera
		call	medzera
return



	END
